/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////
////																					 ////
////																					 ////
////								- SCOL3dSound.cpp -									 ////
////																					 ////
////																					 ////
////				Implmentation des fonctions SCOL de la librairie sonore			 ////
////									 Version  1.0									 ////
////																					 ////
////								  Hilaire Verschuere								 ////
////																					 ////
////																					 ////
/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////
#include "scol/zooscol.h"
#include "scol/scolsound.h"



//$LB TODO TO DO



//////////////////////////////////////////////////////////////////////////////////////////////
///		as3dSndCreate														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d AsSnd I] H3d
int as3dSndCreate(mmachine m)
{
    MMpull(m) ;
    MMpull(m) ;
	MMset(m,0,NIL) ;
	return 0 ;	
}





//////////////////////////////////////////////////////////////////////////////////////////////
///		as3dSndSetDistance
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d I I] H3d
int as3dSndSetDistance(mmachine m)
{
    MMpull(m) ;
    MMpull(m) ;
    MMpull(m) ;
	MMset(m,0,NIL) ;
	return 0 ;	
}

	


//////////////////////////////////////////////////////////////////////////////////////////////
///		as3dSndGetDistance
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] [I I]
int as3dSndGetDistance(mmachine m)
{
    MMpull(m) ;
	MMset(m,0,NIL) ;
	return 0 ;	
}




//////////////////////////////////////////////////////////////////////////////////////////////
///		as3dSndSetCone														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d [I I] I] H3d
int as3dSndSetCone(mmachine m)
{
    MMpull(m) ;
    MMpull(m) ;
    MMpull(m) ;
	MMset(m,0,NIL) ;
	return 0 ;	
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		as3dSndGetCone														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] [I I I]
int as3dSndGetCone(mmachine m)
{
    MMpull(m) ;
	MMset(m,0,NIL) ;
	return 0 ;	
}





//////////////////////////////////////////////////////////////////////////////////////////////
///		as3dSndEnable														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] H3d
int as3dSndEnable(mmachine m)
{
	MMpull(m) ;
	MMset(m,0,NIL) ;
	return 0 ;	
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		as3dSndDisable														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] H3d
int as3dSndDisable(mmachine m)
{
	MMpull(m) ;
	MMset(m,0,NIL) ;
	return 0 ;	
}





//////////////////////////////////////////////////////////////////////////////////////////////
///		as3dListenerCreate 														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d] H3d
int as3dListenerCreate (mmachine m)
{
	MMset(m,0,NIL) ;
	return 0 ;	
}




//////////////////////////////////////////////////////////////////////////////////////////////
///		as3dListenerSetActive														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] H3d
int as3dListenerSetActive(mmachine m)
{
	MMpull(m) ;
	MMset(m,0,NIL) ;
	return 0 ;	
}




//////////////////////////////////////////////////////////////////////////////////////////////
///		as3dListenerSetRollOff													
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d I] H3d
int as3dListenerSetRollOff(mmachine m)
{
    MMpull(m) ;
    MMpull(m) ;
	MMset(m,0,NIL) ;
	return 0 ;	
}







//////////////////////////////////////////////////////////////////////////////////////////////
///		as3dListenerGetRollOff													
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d] I
int as3dListenerGetRollOff(mmachine m)
{
    MMpull(m) ;
	MMset(m,0,NIL) ;
	return 0 ;	
}



/////////////////////////////////////////////////////// DEFINITIONS
#define NBSOUND3DPKG 12

char* SOUND3Dname [ NBSOUND3DPKG ] = 
{
	"AS_SND_LINKED_TO_H3D",			// AS_SND_LINKED_TO_H3D

	// Son 3D				
	"as3dListenerCreate",			// as3dListenerCreate 
	"as3dListenerSetActive",		// as3dListenerSetActive
	"as3dListenerSetRollOff",		// as3dListenerSetRollOff
	"as3dListenerGetRollOff",		// as3dListenerGetRollOff
	"as3dSndCreate",				// as3dSndCreate,
	"as3dSndSetCone",				// as3dSndSetCone
	"as3dSndGetCone",				// as3dSndGetCone
	"as3dSndSetDistance",			// as3dSndSetDistance
	"as3dSndGetDistance",			// as3dSndGetDistance
	"as3dSndEnable",				// as3dSndEnable
	"as3dSndDisable",				// as3dSndDisable
} ;

char * SOUND3Dtype [ NBSOUND3DPKG ] = 
{
	"I",																	// AS_SND_LINKED_TO_H3D
																																						
	// Son 3D																	
	"fun [S3d] H3d",														// as3dListenerCreate 
	"fun [S3d H3d] H3d",													// as3dListenerSetActive
	"fun [S3d H3d I] H3d",													// as3dListenerSetRollOff
	"fun [S3d H3d] I",														// as3dListenerGetRollOff
	"fun [S3d AsSnd I] H3d",												// as3dSndCreate,
	"fun [S3d H3d [I I] I] H3d",											// as3dSndSetCone,
	"fun [S3d H3d] [I I I]",												// as3dSndGetCone
	"fun [S3d H3d I I] H3d",												// as3dSndSetDistance,
	"fun [S3d H3d] [I I]",													// as3dSndGetDistance,
	"fun [S3d H3d] H3d",													// as3dSndEnable
	"fun [S3d H3d] H3d",													// as3dSndDisable																			
} ;


int SOUND3Dnarg [ NBSOUND3DPKG ] = 
{
	TYPVAR,							// AS_SND_LINKED_TO_H3D

	// Son 3D
	1,								// as3dListenerCreate 
	2,								// as3dListenerSetActive
	3,								// as3dListenerSetRollOff,
	2,								// as3dListenerGetRollOff,
	3,								// as3dSndCreate,
	4,								// as3dSndSetCone
	2,								// as3dSndGetCone
	4,								// as3dSndSetDistance
	2,								// as3dSndGetDistance
	2,								// as3dSndEnable
	2,								// as3dSndDisable

} ;


int (*SOUND3Dfun[NBSOUND3DPKG])(mmachine m)= 
{
  //$LB (int (__cdecl *)(struct Mmachine *))(2*AS_SND_LINKED_TO_H3D),	// AS_SND_LINKED_TO_H3D
  0,
 
	// Son 3D														
	as3dListenerCreate ,											// as3dListenerCreate 
	as3dListenerSetActive,											// as3dListenerSetActive
	as3dListenerSetRollOff,											// as3dListenerSetRollOff
	as3dListenerGetRollOff,											// as3dListenerGetRollOff
	as3dSndCreate,													// as3dSndCreate,
	as3dSndSetCone,													// as3dSndSetCone
	as3dSndGetCone,													// as3dSndGetCone
	as3dSndSetDistance,												// as3dSndSetDistance
	as3dSndGetDistance,												// as3dSndGetDistance
	as3dSndEnable,													// as3dSndEnable
	as3dSndDisable,													// as3dSndDisable

} ;



int SCOLload3dSound(mmachine m)
{	
	return PKhardpak( m, "3D Sound", NBSOUND3DPKG, SOUND3Dname, SOUND3Dfun, SOUND3Dnarg, SOUND3Dtype ) ;
}


int SCOLfree3dSound()
{
	return 0;
}

