/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////
////											 ////
////											 ////
////				      - SCOLmp3.cpp -					 ////
////											 ////
////											 ////
////		Implmentation des fonctions SCOL de la librairie sonore		 ////
////				       Version  1.0					 ////
////											 ////
////				   Hilaire Verschuere					 ////
////											 ////
////											 ////
/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////



#include "scol/zooscol.h"
#include "scol/scolsound.h"


/////////////////////////////////////////////////////////////////////////////////////////////
// Static variables
/////////////////////////////////////////////////////////////////////////////////////////////
//$LB extern HSoundManager* pHSoundManager ;


/////////////////////////////////////////////////////////////////////////////////////////////
// Global variables
/////////////////////////////////////////////////////////////////////////////////////////////
int AsMp3 ;



//$LB TODO TO DO



//////////////////////////////////////////////////////////////////////////////////////////////
///		asMp3Create													
//////////////////////////////////////////////////////////////////////////////////////////////
//fun [Chn] AsMp3
int asMp3Create(mmachine m)
{
	MMset(m,0,NIL) ; 
	return MERRMEM ;
}


//////////////////////////////////////////////////////////////////////////////////////////////
///		asMp3Destroy													
//////////////////////////////////////////////////////////////////////////////////////////////
//fun [AsMp3] I
int asMp3Destroy(mmachine m)
{
	MMset(m,0,NIL) ; 
	return 0 ;
}




// Delete the AsMp3 ///////////////////////////////////////////////////////////////////////
int destroyAsMp3(mmachine m,int handsys,int mp3)
{
	return 0;
}




//////////////////////////////////////////////////////////////////////////////////////////////
///		asMp3GetFrameInfo													
//////////////////////////////////////////////////////////////////////////////////////////////
//fun [S] [I I I I]
int asMp3GetFrameInfo(mmachine m)
{	
	MMset(m,0,NIL) ; 
	return 0 ;
}






//////////////////////////////////////////////////////////////////////////////////////////////
///		asMp3Decode													
//////////////////////////////////////////////////////////////////////////////////////////////
//fun [AsMp3 S] S
int asMp3Decode(mmachine m)
{
	MMpull(m);
	MMset(m,0,NIL);
	return 0 ;
}










/////////////////////////////////////////////////////// DEFINITIONS
#define NMP3PKG 5

char * MP3name [ NMP3PKG ] = 
{
	////// TYPES
	"AsMp3",                  //  AsMp3,                   

	////// AsMp3 I/O
	"asMp3Create",			// asMp3Create
	"asMp3Destroy",			// asMp3Destroy
	"asMp3GetFrameInfo",	// asMp3GetFrameInfo
	"asMp3Decode",			// asMp3Decode

} ;

char * MP3type [ NMP3PKG ] = 
{
	////// TYPES                          
	NULL,                   //  AsMp3,                           

	////// AsMp3 I/O
	"fun [Chn] AsMp3",		// asMp3Create,
	"fun [AsMp3] I",			// asMp3Destroy,
	"fun [S] [I I I I]",	// asMp3GetFrameInfo,
	"fun [AsMp3 S] S",		// asMp3Decode 

} ;



int MP3narg [ NMP3PKG ] = 
{
	////// TYPES      
	TYPTYPE,  //  AsMp3,                           

	////// AsMp3 I/O
	1,      // _CRMp3
	1,      // asMp3Destroy
	1,		// asMp3GetFrameInfo
	2,		// asMp3Decode 
} ;




int (*MP3fun[NMP3PKG])(mmachine m)= 
{
	////// TYPES
	NULL,				//  AsMp3,                          

	////// AsMp3 I/O
	asMp3Create,				// asMp3Create
	asMp3Destroy,				// asMp3Destroy
	asMp3GetFrameInfo,	// asMp3GetFrameInfo
	asMp3Decode,			// asMp3Decode

} ;



//$LB : removed cbmachine
int SCOLloadMP3(mmachine m)
{
	AsMp3 = OBJregister( 0, 1, destroyAsMp3, "AsMp3" ) ;

	return PKhardpak( m, "Mp3", NMP3PKG, MP3name, MP3fun, MP3narg, MP3type ) ;
}


int SCOLfreeMP3()
{
	return 0;
}
