/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////
////											 ////
////											 ////
////		 - SCOLrecorder.cpp -							 ////
////											 ////
////											 ////
////			Implmentation des fonctions SCOL de la librairie sonore	 ////
////				    	 Version  1.0					 ////
////										         ////
////						  Hilaire Verschuere			 ////
////											 ////
////											 ////
/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

#include "scol/zooscol.h"
#include "scol/scolsound.h"



/////////////////////////////////////////////////////////////////////////////////////////////
// Static variables
/////////////////////////////////////////////////////////////////////////////////////////////
bool RecorderCreated = false ;


/////////////////////////////////////////////////////////////////////////////////////////////
// Global variables
/////////////////////////////////////////////////////////////////////////////////////////////
int AsRecorder ;
int REC_EVT ;



//$LB TODO TO DO

// old Easy Sound API
//$LB from hutil.h
#define NB_RFL_ASRECORDER	1
#define RFL_ASRECORDER		0

//


//////////////////////////////////////////////////////////////////////////////////////////////
///		asRecorderCreate														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [Chn] AsRecorder
int asRecorderCreate(mmachine m)
{
	MMset(m,0,NIL) ;
	return 0 ;	
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		asRecorderDestroy														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [AsRecorder] I
int asRecorderDestroy(mmachine m)
{
	MMset(m,0,NIL) ;
	return 0 ;	
}





//////////////////////////////////////////////////////////////////////////////////////////////
///		asRecorderInit													
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [AsRecorder fun [AsRecorder u0 S] u1 u0 I I I I I I] AsRecorder
int asRecorderInit(mmachine m)
{
    MMpull(m) ;
    MMpull(m) ;
    MMpull(m) ;
    MMpull(m) ;
    MMpull(m) ;
    MMpull(m) ;
    MMpull(m) ;
    MMpull(m) ;
	MMset(m,0,NIL) ;
	return 0 ;	
}





//////////////////////////////////////////////////////////////////////////////////////////////
///		asRecorderStart													
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [AsRecorder] AsRecorder
int asRecorderStart(mmachine m)
{
	MMset(m,0,NIL) ;
	return 0 ;	
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		asRecorderStop													
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [AsRecorder] AsRecorder
int asRecorderStop(mmachine m)
{
	MMset(m,0,NIL) ;
	return 0 ;	
}


// Delete the AsSnd ///////////////////////////////////////////////////////////////////////
int destroyAsRecorder(mmachine m,int handsys,int asRecorder)
{


	return 0;
}





//////////////////////////////////////////////////////////////////////////////////////////////
///		getRecEvent													
//////////////////////////////////////////////////////////////////////////////////////////////
/*
int getRecEvent(mmachine m,HWND h,unsigned msg,UINT id,LONG param,int *ret)
{
	if( !RecorderCreated ) return 0 ;

	int k ;

	HRecord* pHRecord = (HRecord*)id ;

	int out = MMmalloc( m, STR_SIZE(pHRecord->m_NotifySize) , TYPEBUF ) ;
	MMstore( m, out, 0, pHRecord->m_NotifySize ) ;
	char *S = MMstartstr( m, out ) ;
	_memcpy( S, pHRecord->out, pHRecord->m_NotifySize ) ;
	S[ pHRecord->m_NotifySize ] = 0 ;

	if( !(k = OBJbeginreflex( m, AsRecorder, id, RFL_ASRECORDER ) ) )
	{
		MMpush( m, PTOM( out ) ) ;
		k = OBJcallreflex(m,1) ;
	}

	return k ;
}
*/









/////////////////////////////////////////////////////// DEFINITIONS
#define NBRECORDERPKG 6

char* RECORDERName [ NBRECORDERPKG ] = 
{
	"AsRecorder",					// AsRecorder,

	// Enregistrement
	"asRecorderCreate",				// asRecorderCreate,
	"asRecorderDestroy",			// asRecorderDestroy,
	"asRecorderInit",				// asRecorderInit,
	"asRecorderStart",				// asRecorderStart,
	"asRecorderStop",				// asRecorderStop,
} ;

char* RECORDERtype [ NBRECORDERPKG ] = 
{           
	NULL,																	// AsRecorder,
																					
	// Enregistrement														
	"fun [Chn I] AsRecorder",												// asRecorderCreate,
	"fun [AsRecorder] I",													// asRecorderDestroy,
	"fun [AsRecorder fun [AsRecorder u0 S] u1 u0 I I I I I I] AsRecorder",	// asRecorderInit,
	"fun [AsRecorder] AsRecorder",											// asRecorderStart,,
	"fun [AsRecorder] AsRecorder",											// asRecorderStop,

} ;


int RECORDERnarg [ NBRECORDERPKG ] = 
{
	TYPTYPE,						// AsRecorder,

	//Enregistrement
	2,								// asRecorderCreate,
	1,								// asRecorderDestroy,
	9,								// asRecorderInit,
	1,								// asRecorderStart,
	1,								// asRecorderStop,

} ;


int (*RECORDERfun[NBRECORDERPKG])(mmachine m)= 
{
	NULL,															// AsRecorder,																

	// Enregistrement
	asRecorderCreate,												// asRecorderCreate,
	asRecorderDestroy,												// asRecorderDestroy,
	asRecorderInit,													// asRecorderInit,
	asRecorderStart,												// asRecorderStart,
	asRecorderStop,													// asRecorderStop,

} ;



int SCOLloadRecorder(mmachine m)
{
	AsRecorder = OBJregister( NB_RFL_ASRECORDER, 1, destroyAsRecorder, "AsRecorder" ) ;

	//$LB
	/*
	REC_EVT = OBJgetUserEvent() ;
	OBJdefEvent( REC_EVT,  (int (__cdecl *)(struct Mmachine *,int,unsigned int,int,int,int *))getRecEvent ) ;
	*/

	return PKhardpak( m, "Recorder", NBRECORDERPKG, RECORDERName, RECORDERfun, RECORDERnarg, RECORDERtype ) ;
}



int SCOLfreeRecorder()
{
	return 0;
}
