/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////
////																					 ////
////																					 ////
////								  - SCOLSound.cpp -									 ////
////																					 ////
////																					 ////
////				Implmentation des fonctions SCOL de la librairie sonore			 ////
////									 Version  1.0									 ////
////																					 ////
////								  Hilaire Verschuere								 ////
////																					 ////
////																					 ////
/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////


#include <gdk/gdkx.h>
#include "scol/zooscol.h"
#include "scol/scolsound.h"



/////////////////////////////////////////////////////////////////////////////////////////////
// Static variables
/////////////////////////////////////////////////////////////////////////////////////////////
//$LB HSoundManager* pHSoundManager = NULL ;

HWND hwnd ;


/////////////////////////////////////////////////////////////////////////////////////////////
// Global variables
/////////////////////////////////////////////////////////////////////////////////////////////
int	AsSnd ;
int SND_TIME ;
int SND_NEXT ;



//$LB TODO TO DO

//$LB from hutil.h
#define NB_RFL_ASSND		2
#define RFL_EVT_ASSND		0
#define RFL_NEXT_ASSND		1
//


//////////////////////////////////////////////////////////////////////////////////////////////
///		asSndCreate 														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [Chn I] AsSnd
int asSndCreate(mmachine m)
{
    MMpull(m) ;
	MMset(m,0,NIL) ;
	return 0 ;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		asSndDestroy														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [AsSnd] I
int asSndDestroy (mmachine m)
{
	MMset(m,0,NIL) ;
	return 0 ;
}






//////////////////////////////////////////////////////////////////////////////////////////////
///		asSndCopy 														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [Chn AsSnd] AsSnd
int asSndCopy (mmachine m)
{
    MMpull(m) ;
	MMset(m,0,NIL) ;
	return 0 ;
}




//////////////////////////////////////////////////////////////////////////////////////////////
///		asSndInit 
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [AsSnd I I I I] AsSnd
int asSndInit (mmachine m)
{
	MMpull(m) ;
	MMpull(m) ;
	MMpull(m) ;
	MMpull(m) ;
	MMset(m,0,NIL) ;
	return 0 ;	
}




//////////////////////////////////////////////////////////////////////////////////////////////
///		asSndFeed 
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [AsSnd S I] AsSnd
int asSndFeed (mmachine m)
{
	MMpull(m) ;
	MMpull(m) ;
	MMset(m,0,NIL) ;
	return 0 ;	
}




//////////////////////////////////////////////////////////////////////////////////////////////
///		asSndLoad														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [AsSnd P I] AsSnd
int asSndLoad (mmachine m)
{	
    MMpull(m) ;
	MMpull(m) ;
	MMset(m,0,NIL) ;
	return 0 ;	
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		asSndNext														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [AsSnd fun [AsSnd u0] u1 u0 P] AsSnd
int asSndNext (mmachine m)
{
  SEDROP(m, 3);
  MMset(m, 0, NIL);
  return 0;
} 



///////////////////////////////////////////////////////////////////////////////////////////////
///		asSndPlay														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [AsSnd I] AsSnd
int asSndPlay (mmachine m)
{
	MMpull(m) ;
	MMset(m,0,NIL) ;
	return 0 ;	
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		asSndStop														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [AsSnd] AsSnd
int asSndStop (mmachine m)
{
	MMset(m,0,NIL) ;
	return 0 ;	
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		asSndIsPlaying
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [AsSnd] I
int asSndIsPlaying (mmachine m)
{
	MMset(m,0,NIL) ;
	return 0 ;	
}





//////////////////////////////////////////////////////////////////////////////////////////////
///		asEnableAllSnd														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [] I
int asEnableAllSnd (mmachine m)
{
	MMpush(m,NIL) ;
	return 0 ;	
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		asDisableAllSnd														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [] I
int asDisableAllSnd (mmachine m)
{
	MMpush(m,NIL) ;
	return 0 ;	
}




//////////////////////////////////////////////////////////////////////////////////////////////
///		asSndReset														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [AsSnd] AsSnd
int asSndReset (mmachine m)
{
	MMset(m,0,NIL) ;
	return 0 ;	
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		asSndGetSize														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [AsSnd] I
int asSndGetSize (mmachine m)
{
	MMset(m,0,NIL) ;
	return 0 ;	
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		asSndSetTime														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [AsSnd I I] AsSnd
int asSndSetTime (mmachine m)
{
	MMpull(m) ;
	MMpull(m) ;
	MMset(m,0,NIL) ;
	return 0 ;	
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		asSndGetTime														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [AsSnd] I
int asSndGetTime (mmachine m)
{
	MMset(m,0,NIL) ;
	return 0 ;	
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		asSetVolume 														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [I] I
int asSetVolume  (mmachine m)
{
	MMset(m,0,NIL) ;
	return 0 ;	
}




//////////////////////////////////////////////////////////////////////////////////////////////
///		asGetVolume 														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [] I
int asGetVolume  (mmachine m)
{
	MMpush(m,NIL) ;
	return 0 ;	
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		asSndSetVolume														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [AsSnd I] AsSnd
int asSndSetVolume (mmachine m)
{
	MMpull(m) ;
	MMset(m,0,NIL) ;
	return 0 ;	
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		asSndGetVolume														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [AsSnd] I
int asSndGetVolume (mmachine m)
{
	MMset(m,0,NIL) ;
	return 0 ;	
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		asSndSetPan 														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [AsSnd I] AsSnd
int asSndSetPan  (mmachine m)
{
	MMpull(m) ;
	MMset(m,0,NIL) ;
	return 0 ;	
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		asSndGetPan														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [AsSnd] I
int asSndGetPan (mmachine m)
{
	MMset(m,0,NIL) ;
	return 0 ;	
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		asSndSetFrequency														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [AsSnd I] AsSnd
int asSndSetFrequency (mmachine m)
{
	MMpull(m) ;
	MMset(m,0,NIL) ;
	return 0 ;	
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		asSndGetFrequency														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [AsSnd] I
int asSndGetFrequency (mmachine m)
{
	MMset(m,0,NIL) ;
	return 0 ;	
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		asSndSetCallBackTime														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [AsSnd fun [AsSnd u0] u1 u0 [I r1]] AsSnd
int asSndSetCallbackTime(mmachine m)
{
    MMpull(m) ;
    MMpull(m) ;
    MMpull(m) ;
	MMset(m,0,NIL) ;
	return 0 ;	
}




// Delete the AsSnd ///////////////////////////////////////////////////////////////////////
int destroyAsSnd(mmachine m,int handsys,int asSnd)
{


	return 0;
}







//////////////////////////////////////////////////////////////////////////////////////////////
///		getNextEvent														
//////////////////////////////////////////////////////////////////////////////////////////////
/*
int getNextEvent(mmachine m,HWND h,unsigned msg,UINT id,LONG param,int *ret)
{
	int k ;

	if( !(k = OBJbeginreflex( m, AsSnd, id, RFL_NEXT_ASSND ) ) ) k = OBJcallreflex(m,0) ;

	return k ;
}
*/







//////////////////////////////////////////////////////////////////////////////////////////////
///		getSoundEvent														
//////////////////////////////////////////////////////////////////////////////////////////////
/*
int getSoundEvent(mmachine m,HWND h,unsigned msg,UINT id,LONG param,int *ret)
{
	int k ;

	if( !(k = OBJbeginreflex( m, AsSnd, id, RFL_EVT_ASSND ) ) ) k = OBJcallreflex(m,0) ;

	return k ;
}
*/









/////////////////////////////////////////////////////// DEFINITIONS
#define NBSOUNDPKG 38

char* SOUNDname [ NBSOUNDPKG ] = 
{
	"AsSnd",						// AsSnd,

	"AS_SND_STATIC",				// AS_SND_STATIC,
	"AS_SND_STREAMING",				// AS_SND_STREAMING,								

	"AS_SND_BEGIN",					// AS_SND_BEGIN,
	"AS_SND_CURRENT",				// AS_SND_CURRENT,
	"AS_SND_END",					// AS_SND_END,
		
	"AS_SND_CTRL3D",				// AS_SND_CTRL3D,
	"AS_SND_CTRLFREQUENCY",			// AS_SND_CTRLFREQUENCY,
	"AS_SND_CTRLPAN",				// AS_SND_CTRLPAN,

	"AS_SND_LINEAR",				// AS_SND_LINEAR
	"AS_SND_CIRCULAR",				// AS_SND_CIRCULAR

	"AS_SND_END_REFLEX",			// AS_SND_END_REFLEX
	"AS_SND_LOOP",					// AS_SND_LOOP

	// Son 2D		
	"asSndCreate",					// asSndCreate,
	"asSndDestroy",					// asSndDestroy,
	"asSndInit",					// asSndInit ,
	"asSndFeed",					// asSndFeed ,
	"asSndLoad",					// asSndLoad,
	"asSndNext",					// asSndNext,
	"asSndCopy",					// asSndCopy 
	"asSndPlay",					// asSndPlay,
	"asSndStop",					// asSndStop,
	"asSndIsPlaying",				// asSndIsPlaying
	"asEnableAllSnd",				// asEnableAllSnd,
	"asDisableAllSnd",				// asDisableAllSndAllSnd,
	"asSndReset",					// asSndReset,
	"asSndGetSize",					// asSndGetSize,
	"asSndSetTime",					// asSndSetTime,
	"asSndGetTime",					// asSndGetTime
	"asSndSetVolume",				// asSndSetVolume,
	"asSndGetVolume",				// asSndGetVolume,
	"asSetVolume",					// asSetVolume ,
	"asGetVolume",					// asGetVolume ,
	"asSndSetPan",					// asSndSetPan ,
	"asSndGetPan",					// asSndGetPan
	"asSndSetFrequency",			// asSndSetFrequency
	"asSndGetFrequency",			// asSndGetFrequency
	"asSndSetCallbackTime",			// asSndSetCallbackTime
} ;

char * SOUNDtype [ NBSOUNDPKG ] = 
{
////// TYPES                          
	NULL,																	// AsSnd,
																					
	"I",																	// AS_SND_STATIC,
	"I",																	// AS_SND_STREAMING,
																					
	"I",																	// AS_SND_BEGIN,
	"I",																	// AS_SND_CURRENT,
	"I",																	// AS_SND_END,
																				
	"I",																	// AS_SND_CTRL3D,
	"I",																	// AS_SND_CTRLFREQUENCY,
	"I",																	// AS_SND_CTRLPAN,
																			
	"I",																	// AS_SND_LINEAR
	"I",																	// AS_SND_CIRCULAR
																			
	"I",																	// AS_SND_END_REFLEX
	"I",																	// AS_SND_LOOP
																			
	// Son 2D																
	"fun [Chn I] AsSnd",													// asSndCreate,
	"fun [AsSnd] I",														// asSndDestroy,																				
	"fun [AsSnd I I I I] AsSnd",											// asSndInit ,
	"fun [AsSnd S I] AsSnd",												// asSndFeed 																						
	"fun [AsSnd P I] AsSnd",												// asSndLoad,
	"fun [AsSnd fun [AsSnd u0] u1 u0 P] AsSnd",								// asSndNext
	"fun [Chn AsSnd] AsSnd",												// asSndCopy 																			
	"fun [AsSnd I] AsSnd",													// asSndPlay,
	"fun [AsSnd] AsSnd",													// asSndStop,
	"fun [AsSnd] I",														// asSndIsPlaying
	"fun [] I",																// asEnableAllSnd,
	"fun [] I",																// asDisableAllSnd,
	"fun [AsSnd] AsSnd",													// asSndReset,
	"fun [AsSnd] I",														// asSndGetSize,
	"fun [AsSnd I I] AsSnd",												// asSndSetTime,
	"fun [AsSnd] I",														// asSndGetTime
	"fun [AsSnd I] AsSnd",													// asSndSetVolume,
	"fun [AsSnd] I",														// asSndGetVolume
	"fun [I] I",															// asSetVolume ,
	"fun [] I",																// asGetVolume ,
	"fun [AsSnd I] AsSnd",													// asSndSetPan ,
	"fun [AsSnd] I",														// asSndGetPan,
	"fun [AsSnd I] AsSnd",													// asSndSetFrequency,
	"fun [AsSnd] I",														// asSndGetFrequency,
	"fun [AsSnd fun [AsSnd u0] u1 u0 [I r1]] AsSnd",						// asSndSetCallbackTime																		
} ;


int SOUNDnarg [ NBSOUNDPKG ] = 
{
	TYPTYPE,						// AsSnd,

	TYPVAR,							// AS_SND_STATIC,
	TYPVAR,							// AS_SND_STREAMING,
	
	TYPVAR,							// AS_SND_BEGIN,
	TYPVAR,							// AS_SND_CURRENT,
	TYPVAR,							// AS_SND_END,

	TYPVAR,							// AS_SND_CTRL3D,
	TYPVAR,							// AS_SND_CTRLFREQUENCY,
	TYPVAR,							// AS_SND_CTRLPAN,

	TYPVAR,							// AS_SND_LINEAR
	TYPVAR,							// AS_SND_CIRCULAR

	TYPVAR,							// AS_SND_END_REFLEX
	TYPVAR,							// AS_SND_LOOP

	// Son 2D
	2,								// asSndCreate,
	1,								// asSndDestroy,
	5,								// asSndInit 
	3,								// asSndFeed 
	3,								// asSndLoad,
	4,								// asSndNext,
	2,								// asSndCopy 
	2,								// asSndPlay,
	1,								// asSndStop,
	1,								// asSndIsPlaying
	0,								// asEnableAllSnd,
	0,								// asDisableAllSnd,
	1,								// asSndReset,
	1,								// asSndGetSize,
	3,								// asSndSetTime,
	1,								// asSndGetTime,
	2,								// asSndSetVolume,
	1,								// asSndGetVolume
	1,								// asSetVolume ,
	0,								// asGetVolume ,
	2,								// asSndSetPan ,
	1,								// asSndGetPan,
	2,								// asSndSetFrequency,
	1,								// asSndGetFrequency,
	4,								// asSndSetCallbackTime
} ;


int (*SOUNDfun[NBSOUNDPKG])(mmachine m)= 
{
	NULL,															// AsSnd,

	//$LB
	/*
	(int (__cdecl *)(struct Mmachine *))(2*AS_SND_STATIC),			// AS_SND_STATIC,
	(int (__cdecl *)(struct Mmachine *))(2*AS_SND_STREAMING),		// AS_SND_STREAMING,
																	
	(int (__cdecl *)(struct Mmachine *))(2*SEEK_SET),				// AS_SND_BEGIN,
	(int (__cdecl *)(struct Mmachine *))(2*SEEK_CUR),				// AS_SND_CURRENT,
	(int (__cdecl *)(struct Mmachine *))(2*SEEK_END),				// AS_SND_END,
																	
	(int (__cdecl *)(struct Mmachine *))(2*DSBCAPS_3D),				// AS_SND_CTRL3D,
	(int (__cdecl *)(struct Mmachine *))(2*DSBCAPS_CTRLFREQUENCY),	// AS_SND_CTRLFREQUENCY,
	(int (__cdecl *)(struct Mmachine *))(2*DSBCAPS_CTRLPAN),		// AS_SND_CTRLPAN,

	(int (__cdecl *)(struct Mmachine *))(2*AS_SND_LINEAR),			// AS_SND_LINEAR
	(int (__cdecl *)(struct Mmachine *))(2*AS_SND_CIRCULAR),		// AS_SND_CIRCULAR

	(int (__cdecl *)(struct Mmachine *))(2*AS_SND_END_REFLEX),		// AS_SND_END_REFLEX
	(int (__cdecl *)(struct Mmachine *))(2*AS_SND_LOOP),			// AS_SND_LOOP
	*/
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
 
	// Son 2D													
	asSndCreate,													// asSndCreate,
	asSndDestroy,													// asSndDestroy,
	asSndInit,														// asSndInit 
	asSndFeed,														// asSndFeed 
	asSndLoad,														// asSndLoad,
	asSndNext,														// asSndNext,
	asSndCopy,														// asSndCopy 
	asSndPlay,														// asSndPlay,
	asSndStop,														// asSndStop,
	asSndIsPlaying,													// asSndIsPlaying,
	asEnableAllSnd,													// asEnableAllSnd,
	asDisableAllSnd,												// asDisableAllSnd,
	asSndReset,														// asSndReset,
	asSndGetSize,													// asSndGetSize,
	asSndSetTime,													// asSndSetTime,
	asSndGetTime,													// asSndGetTime,
	asSndSetVolume,													// asSndSetVolume,
	asSndGetVolume,													// asSndGetVolume,
	asSetVolume,													// asSetVolume ,
	asGetVolume,													// asGetVolume ,
	asSndSetPan,													// asSndSetPan ,
	asSndGetPan,													// asSndGetPan,
	asSndSetFrequency,												// asSndSetFrequency,
	asSndGetFrequency,												// asSndGetFrequency,
	asSndSetCallbackTime,											// asSndSetCallbackTime																	
} ;




int SCOLloadSound(mmachine m)
{
	int res = 0 ;

	//$LB hwnd = (HWND)SCgetExtra("hscol") ;
	hwnd = GDK_ROOT_PARENT ();

	AsSnd =	OBJregister( NB_RFL_ASSND, 1, destroyAsSnd, "AsSnd") ;
	
	//$LB
	/*
	SND_TIME = OBJgetUserEvent() ;
	OBJdefEvent( SND_TIME, (int (__cdecl *)(struct Mmachine *,int,unsigned int,int,int,int *))getSoundEvent ) ;

	SND_NEXT = OBJgetUserEvent() ;
	OBJdefEvent( SND_NEXT, (int (__cdecl *)(struct Mmachine *,int,unsigned int,int,int,int *))getNextEvent ) ;
	*/

	res += SCOLload3dSound(m) ;	
	res += SCOLloadRecorder(m) ;	
	res += SCOLloadWave(m) ;	
	res += SCOLloadMP3(m) ;		
	res += SCOLloadSDSound(m) ;
	res += SCOLloadEasySound(m) ;
	
	res += PKhardpak( m, "Sound", NBSOUNDPKG, SOUNDname, SOUNDfun, SOUNDnarg, SOUNDtype ) ;

	return res ;
}



int SCOLfreeSound()
{
	SCOLfree3dSound() ;
	SCOLfreeRecorder() ;
	SCOLfreeWave() ;
	SCOLfreeMP3() ;
	SCOLfreeSDSound() ;
	SCOLfreeEasySound() ;
	//$LB SAFE_DELETE(pHSoundManager) ;
	MMechostr(1,"Release DirectSound.\n");

	return 0;
}













