/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////
////																					 ////
////																					 ////
////								  - SCOLwave.cpp -									 ////
////																					 ////
////																					 ////
////				Implmentation des fonctions SCOL de la librairie sonore			 ////
////									 Version  1.0									 ////
////																					 ////
////								  Hilaire Verschuere								 ////
////																					 ////
////																					 ////
/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

#include	"scol/zooscol.h"


/////////////////////////////////////////////////////////////////////////////////////////////
// Static variables
/////////////////////////////////////////////////////////////////////////////////////////////
//$LB extern HSoundManager* pHSoundManager ;


/////////////////////////////////////////////////////////////////////////////////////////////
// Global variables
/////////////////////////////////////////////////////////////////////////////////////////////

int AsWave ;



//$LB TODO TO DO



//////////////////////////////////////////////////////////////////////////////////////////////
///		asWaveCreate													
//////////////////////////////////////////////////////////////////////////////////////////////
//fun [Chn P] AsWave
int asWaveCreate(mmachine m)
{
    MMpull(m) ;
	MMset(m,0,NIL);
	return 0 ;
}


//////////////////////////////////////////////////////////////////////////////////////////////
///		asWaveDestroy 													
//////////////////////////////////////////////////////////////////////////////////////////////
//fun [AsWave] I
int asWaveDestroy (mmachine m)
{
	MMset(m,0,NIL) ;
	return 0 ;
}


// Delete the AsWave ///////////////////////////////////////////////////////////////////////
int destroyAsWave(mmachine m,int handsys,int wave)
{

	return 0;
}





//////////////////////////////////////////////////////////////////////////////////////////////
///		asWaveGetInfo													
//////////////////////////////////////////////////////////////////////////////////////////////
//fun [P] [I I I I]
int asWaveGetInfo(mmachine m)
{
	MMset(m,0,NIL);
	return 0 ;
}







//////////////////////////////////////////////////////////////////////////////////////////////
///		asWaveRead													
//////////////////////////////////////////////////////////////////////////////////////////////
//fun [AsWave I I I] S
int asWaveRead(mmachine m)
{
    MMpull(m) ;
	MMpull(m) ;
	MMpull(m) ;
	MMset(m,0,NIL);
	return 0 ;
}








//////////////////////////////////////////////////////////////////////////////////////////////
///		asWaveSeek													
//////////////////////////////////////////////////////////////////////////////////////////////
//fun [AsWave I I] AsWave
int asWaveSeek(mmachine m)
{
  SEDROP(m,2);
  MMset(m,0,NIL);

	return 0 ;
}




/////////////////////////////////////////////////////// DEFINITIONS
#define NBWAVEPKG 10

char* WAVEname [ NBWAVEPKG ] = 
{
	////// TYPES             
	"AsWave",               // AsWave,
	"AS_WAVE_BEGIN",		// AS_WAVE_BEGIN,
	"AS_WAVE_CURRENT",		// AS_WAVE_CURRENT,
	"AS_WAVE_END",			// AS_WAVE_END,
	"AS_WAVE_LOOP",			// AS_WAVE_LOOP

	// WAVE I/O
	"asWaveCreate",			// asWaveCreate
	"asWaveDestroy",		// asWaveDestroy 
	"asWaveGetInfo",		// asWaveGetInfo
	"asWaveRead",			// asWaveRead
	"asWaveSeek",			// asWaveSeek
} ;

char * WAVEtype [ NBWAVEPKG ] = 
{
	////// TYPES                          
	NULL,						// AsWave,
	"I",						// AS_WAVE_BEGIN,
	"I",						// AS_WAVE_CURRENT,
	"I",						// AS_WAVE_END,
	"I",						// AS_WAVE_LOOP
								
	// WAVE I/O					
	"fun [Chn P] AsWave",		// asWaveCreate
	"fun [AsWave] I",			// asWaveDestroy 
	"fun [AsWave] [I I I I]",	// asWaveGetInfo
	"fun [AsWave I I] S",		// asWaveRead
	"fun [AsWave I I] I",		// asWaveSeek
} ;


int WAVEnarg [ NBWAVEPKG ] = 
{
	////// TYPES   
	TYPTYPE,		// AsWave,
	TYPVAR,			// AS_WAVE_BEGIN,
	TYPVAR,			// AS_WAVE_CURRENT,
	TYPVAR,			// AS_WAVE_END,
	TYPVAR,			// AS_WAVE_LOOP
					
	// WAVE I/O		
	2,				// asWaveCreate
	1,				// asWaveDestroy
	1,				// asWaveGetInfo
	3,				// asWaveRead
	3,				// asWaveSeek

} ;


int (*WAVEfun[NBWAVEPKG])(mmachine m)= 
{
	////// TYPES             
	NULL,													// AsWave,
	(int (__cdecl *)(struct Mmachine *))(2*SEEK_SET),		// AS_WAVE_BEGIN,
	(int (__cdecl *)(struct Mmachine *))(2*SEEK_CUR),		// AS_WAVE_CURRENT,
	(int (__cdecl *)(struct Mmachine *))(2*SEEK_END),		// AS_WAVE_END,
	//$LB (int (__cdecl *)(struct Mmachine *))(2*AS_WAVE_LOOP),	// AS_WAVE_LOOP,	
	0,

	// WAVE I/O
	asWaveCreate,											// asWaveCreate
	asWaveDestroy ,											// asWaveDestroy 
	asWaveGetInfo,											// asWaveGetInfo
	asWaveRead,												// asWaveRead
	asWaveSeek,												// asWaveSeek
} ;


int SCOLloadWave(mmachine m)
{
	AsWave = OBJregister( 0, 1, destroyAsWave, "AsWave" ) ;

	return PKhardpak( m, "Wave", NBWAVEPKG, WAVEname, WAVEfun, WAVEnarg, WAVEtype );
}



int SCOLfreeWave()
{
	return 0;
}


