//$LB OK
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////														   ////
///		    GESTION DE RENDU										    ///
////														   ////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZMX3hardware
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [] I
int ZMX3hardware(mmachine m)
{
	if(scolGLX->userACCEL)		return MMpush(m,ITOM(1));
	else				return MMpush(m,ITOM(0));
}


/*
//////////////////////////////////////////////////////////////////////////////////////////////
///		MX3getDeviceList
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [] [[S S] r1]
int MX3getDeviceList(mmachine m)
{
	int i,k;
	for(i=0;i<_MX3nb;i++)
	{
		if (k=Mpushstrbloc(m,_MX3clear[i])) return k;
		if (k=Mpushstrbloc(m,_MX3id[i])) return k;
		if (MMpush(m,2*2)) return MERRMEM;
		if (k=MBdeftab(m)) return k;
	}
	if (MMpush(m,NIL)) return MERRMEM;
	for(i=0;i<_MX3nb;i++)
	{
		if (MMpush(m,2*2)) return MERRMEM;
		if (k=MBdeftab(m)) return k;
	}
	return 0;
}
*/





///////////////////////////////////////////////////////////////////////////////////////
///		Macro GLOBAL_RENDER_FILL					    ///
///////////////////////////////////////////////////////////////////////////////////////
#define GLOBAL_RENDER_FILL(flag_of_wired)								   \
	int		fond, y, x, h3d, surf, s3d;							   \
	ZScene	*scene;											   \
	ZNode	*node, *father;										   \
	/*/////////////////////////////////////////////////////////////////				   \
	///		RENDU HARD					///                                \
	/////////////////////////////////////////////////////////////////*/				   \
	if(scolGLX->userACCEL)										   \
	{			                                                                           \
		HGLRC	hglrc;										   \
                HWND    hwnd;                                                                              \
													   \
		fond = MMpull(m);									   \
		y	 = MMpull(m);									   \
		x	 = MMpull(m);									   \
		h3d	 = MMpull(m);									   \
		surf = MMpull(m);									   \
													   \
		if(surf==NIL) 		{   MMset(m,0,NIL);		return 0;	}		   \
													   \
		hglrc	= (HGLRC) MMfetch(m,MTOP(surf),2);						   \
                hwnd    = (HWND) MMfetch(m, MTOP(surf), 3);                                                \
													   \
		if(wglGetCurrentContext()!=hglrc)							   \
		{											   \
			wglMakeCurrent(hwnd,hglrc);							   \
		}											   \
													   \
		s3d = MMget(m,0);									   \
		if((s3d==NIL)||(h3d==NIL))		{   MMset(m,0,NIL);		return 0;	}  \
													   \
		scene = (ZScene*) MMfetch(m,MTOP(s3d),0);						   \
		if(scene==NULL || scene->accelerated==false)	{ MMset(m,0,NIL); return 0;	}	   \
													   \
		/* Couleur de Fond */									   \
		fond = MTOI(fond);									   \
		float	r = 0;										   \
		float	g = 0;										   \
		float	b = 0;										   \
													   \
		if(fond!=NIL)										   \
		{											   \
			r = ((fond)&255)	 / CONST_COLOR;						   \
			g = ((fond>>8)&255)	 / CONST_COLOR;						   \
			b = ((fond>>16)&255) / CONST_COLOR;						   \
		}											   \
													   \
		/* Recupration de la camera */								   \
		node = (ZNode*) MMfetch(m,MTOP(h3d),0);							   \
		if((node==NULL)||(node->type!=CAM_TYPE_ID))		{ MMset(m,0,NIL); return 0; }	   \
		scene->SetActiveCam((ZCamera*)node);							   \
													   \
		father = getBigFather(node);								   \
													   \
													   \
		/* Prpare la camera par prcaution et aussi pour le calcul des subMatrices */		   \
		ZMatrix		matx = ComputeWorldMatrix(node);					   \
		((ZCamera*)node)->worldMat = matx;							   \
		((ZCamera*)node)->worldPos.SetCoord(matx(0,3), matx(1,3), matx(2,3));			   \
													   \
		/* Rendu de la scene */									   \
		if(fond==NIL)		scene->Display(r,g,b, father, flag_of_wired, false, false);	   \
		else				scene->Display(r,g,b, father, flag_of_wired, false, true); \
	}												   \
	/*/////////////////////////////////////////////////////////////////				   \
	///		RENDU SOFT					///                                \
	/////////////////////////////////////////////////////////////////*/				   \
	else												   \
	{												   \
		fond = MMpull(m);									   \
		y	 = MMpull(m);									   \
		x	 = MMpull(m);									   \
		h3d	 = MMpull(m);									   \
		surf = MMpull(m);									   \
		s3d  = MMget(m,0);									   \
													   \
		if((surf==NIL)||(s3d==NIL)||(h3d==NIL)||scolGLX->fullscreenMode)	   { MMset(m,0,NIL); return 0; }   \
													   \
		scene = (ZScene*) MMfetch(m,MTOP(s3d),0);						   \
		if(scene==NULL)						   { MMset(m,0,NIL); return 0; }   \
													   \
		RenderBuffer	buffer;									   \
		if(fillRenderBuffer(m, &buffer, surf))			{ MMset(m,0,NIL); return 0; }	   \
													   \
		/* Couleur de Fond */									   \
		fond = MTOI(fond);									   \
		float	r = 0;										   \
		float	g = 0;										   \
		float	b = 0;										   \
													   \
		if(fond!=NIL)										   \
		{											   \
			r = ((fond)&255)	 / CONST_COLOR;						   \
			g = ((fond>>8)&255)	 / CONST_COLOR;						   \
			b = ((fond>>16)&255) / CONST_COLOR;						   \
		}											   \
													   \
		/* Recupration de la camera */								   \
		node = (ZNode*) MMfetch(m,MTOP(h3d),0);							   \
		if((node==NULL)||(node->type!=CAM_TYPE_ID))		{ MMset(m,0,NIL); return 0; }	   \
		scene->SetActiveCam((ZCamera*)node);							   \
													   \
		father = getBigFather(node);								   \
													   \
		/* Prpare la camera par prcaution et aussi pour le calcul des subMatrices */		   \
		ZMatrix		matx = ComputeWorldMatrix(node);					   \
		((ZCamera*)node)->worldMat = matx;							   \
		((ZCamera*)node)->worldPos.SetCoord(matx(0,3), matx(1,3), matx(2,3));			   \
													   \
		/* Rendu de la scene */									   \
		if(fond==NIL) scene->DisplaySOFT(&buffer, r, g, b, father, flag_of_wired, false, false);   \
		else scene->DisplaySOFT(&buffer, r, g, b, father, flag_of_wired, false, true);	           \
	}





///////////////////////////////////////////////////////////////////////////////////////
///		Macro CLEAN_UNUSED_DATAS					    ///
///////////////////////////////////////////////////////////////////////////////////////
#define CLEAN_UNUSED_DATAS										   \
													   \
	/* ---> Nettoyage des objets non rfrencs et dj utiliss <---	*/			   \
	ZMesh	*mesh;											   \
	int		hash_h3d = MTOP(MMfetch(m,MTOP(s3d),1));					   \
	int		hash_mat = MTOP(MMfetch(m,MTOP(s3d),2));					   \
	int		hash_tex = MTOP(MMfetch(m,MTOP(s3d),3));					   \
													   \
        int j;                                                                                             \
	for(j=0; j < scene->MshList.Size(); j++)							   \
	{												   \
		mesh = scene->MshList[j];								   \
		if((mesh->nbRef==0)&&(mesh->referenced))						   \
		{											   \
			int	h3ddel = NodeTOHandle(m, hash_h3d, (int)mesh);				   \
			DelObj(m, hash_h3d, h3ddel);							   \
			delete mesh;									   \
			scene->MshList.DeleteIndex(j);							   \
			j--;										   \
		}											   \
	}												   \
	ZMaterial	*material;									   \
	for(j=0; j < scene->MatList.Size(); j++)							   \
	{												   \
		material = scene->MatList[j];								   \
		if((material->nbRef==0)&&(material->referenced))					   \
		{											   \
			int	h3ddel = NodeTOHandle(m, hash_mat, (int)material);			   \
			DelObj(m, hash_mat, h3ddel);							   \
			delete material;								   \
			scene->MatList.DeleteIndex(j);							   \
			j--;										   \
		}											   \
	}												   \
	ZTexture	*texture;									   \
	for(j=0; j < scene->TexList.Size(); j++)							   \
	{												   \
		texture = scene->TexList[j];								   \
		if((texture->nbRef==0)&&(texture->referenced))						   \
		{											   \
			int	h3ddel = NodeTOHandle(m, hash_tex, (int)texture);			   \
			DelObj(m, hash_tex, h3ddel);							   \
			delete texture;									   \
			scene->TexList.DeleteIndex(j);							   \
			j--;										   \
		}											   \
	}






#define PROCEED_RENDER_CALLBACK										   \
	/* Traitement des callbacks de rendu */								   \
	ZScene	*sce;											   \
	int S3d = MMget(m,5);										   \
	if(S3d!=NIL)											   \
	{												   \
		sce = (ZScene*) MMfetch(m,MTOP(S3d),0);							   \
		if(sce!=NULL)										   \
		{											   \
			int cb, nh3d, res;								   \
			ZMesh *curObj;									   \
			for(int i=0;i<sce->cbObj.Size();i++)						   \
			{										   \
				curObj	= sce->cbObj[i];						   \
				nh3d	= NodeTOHandle(m, MTOP(MMfetch(m,MTOP(S3d),1)), (int)curObj);	   \
				cb		= MMfetch(m,nh3d,2);					   \
				MMpush(m, PTOM( nh3d ));						   \
				MMpush(m, cb);								   \
				if((res = Minterpreter(m)) < 0)						   \
					return res;							   \
				UpdateH3d(sce, curObj, m);						   \
			}										   \
		}											   \
	}												   \





// fun [S3d H3d fun [H3d] [[[[F F F] I I] r1] [[HMat3d I F F F F I F F F F I F F F F] r1]]] H3d
int M3setRenderCallback(mmachine m)
{
	int cb		=		MMpull(m);
	int h3d		= MTOP( MMpull(m) );
	int s3d		= MTOP( MMget(m,0));

	if((s3d==NIL)||(h3d==NIL))								{   MMset(m,0,NIL);		return 0;	}

	ZNode	*node = (ZNode*) MMfetch(m,h3d,0);
	if((node==NULL)||(node->type!=MSH_TYPE_ID))				{   MMset(m,0,NIL);		return 0;	}

	ZScene	*scene = (ZScene*) MMfetch(m,s3d,0);
	if(scene==NULL)											{	MMset(m,0,NIL);		return 0;	}

	MMstore(m, h3d, 2, cb);

	int pos;

	if(cb==NIL) scene->cbObj.Delete((ZMesh*)node);
	else if(scene->cbObj.Contains((ZMesh*)node, &pos)==false)
	{
		scene->cbObj.Add((ZMesh*)node);
		((ZMesh*)node)->displayListCreate = false;
	}


	MMset(m,0,PTOM(h3d));

	return 0;
}


int UpdateH3d(ZScene *scene, ZMesh *curMesh, mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"Begin -- RenderCallback\n");
#endif
	int data	= MTOP( MMpull(m));

	if(data!=NIL)
	{
		int vertexlist	= MTOP( MMfetch(m,data,0)); 
		int facelist	= MTOP( MMfetch(m,data,1));

		curMesh->Verts.resize(0);
		for(int iii=0; iii<curMesh->NbFaces; iii++)		curMesh->Faces[iii].DeleteFace();
		curMesh->Faces.resize(0);
		curMesh->NbFaces = curMesh->NbVerts = 0;

		ZVert curVert;
		int vertex, tup, vc0, vc1;
		float x,y,z;
		while(vertexlist!=NIL)
		{
			tup		= MTOP( MMfetch(m,vertexlist,0)); 
			vertex	= MTOP( MMfetch(m,tup,0));
			x		= MTOF( MMfetch(m,vertex,0));
			y		= MTOF( MMfetch(m,vertex,1));
			z		= MTOF( MMfetch(m,vertex,2));
			vc0		= MTOI( MMfetch(m,tup,1));
			vc1		= MTOI( MMfetch(m,tup,2));

			curVert.SetCoord(x/100.0f,y/100.0f,-z/100.0f);

			curVert.color1.SetCoord(	((float)((vc0&0x00ff0000)>>16)) / CONST_COLOR,
		 								((float)((vc0&0x0000ff00)>>8) ) / CONST_COLOR,
										((float) (vc0&0x000000ff)	  )  / CONST_COLOR  );
			curVert.color2.SetCoord(	((float)((vc1&0x00ff0000)>>16)) / CONST_COLOR,
		 								((float)((vc1&0x0000ff00)>>8) ) / CONST_COLOR,
										((float) (vc1&0x000000ff)	  )  / CONST_COLOR  );
			curMesh->addVert(curVert);

			vertexlist	= MTOP( MMfetch(m,vertexlist,1));		
		}

		ZNode		*node;
		ZMaterial	*mat;

		ZFace	face;
		while(facelist!=NIL)
		{
			tup				= MTOP( MMfetch(m,facelist,0));
			vertex			= MTOP( MMfetch(m,tup,0));
		
			node			= (ZNode*) MMfetch(m,vertex,0);
			if((node==NULL)||(node->type!=MAT_TYPE_ID))					{	MMset(m,0,NIL);		return 0;	}
			mat		= (ZMaterial*) node;

			face.initFace();
			face.SetMaterial(mat);

			face.VertRef[0]	= MTOI( MMfetch(m,tup,1));
			face.UV1[0].u	= MTOF( MMfetch(m,tup,2));
			face.UV1[0].v	= MTOF( MMfetch(m,tup,3));
			face.UV2[0].u	= MTOF( MMfetch(m,tup,4));
			face.UV2[0].v	= MTOF( MMfetch(m,tup,5));

			face.VertRef[1]	= MTOI( MMfetch(m,tup,6));
			face.UV1[1].u	= MTOF( MMfetch(m,tup,7));
			face.UV1[1].v	= MTOF( MMfetch(m,tup,8));
			face.UV2[1].u	= MTOF( MMfetch(m,tup,9));
			face.UV2[1].v	= MTOF( MMfetch(m,tup,10));

			face.VertRef[2]	= MTOI( MMfetch(m,tup,11));
			face.UV1[2].u	= MTOF( MMfetch(m,tup,12));
			face.UV1[2].v	= MTOF( MMfetch(m,tup,13));
			face.UV2[2].u	= MTOF( MMfetch(m,tup,14));
			face.UV2[2].v	= MTOF( MMfetch(m,tup,15));

		
			curMesh->addFace(face);
			face.SetMaterial(NULL);

			facelist		= MTOP( MMfetch(m,facelist,1));		
		}

		curMesh->hasTopoChanged = curMesh->hasViewChanged = scene->meshModified = true;
	}

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"End -- RenderCallback\n");
#endif
	return 0;
}

//////////////////////////////////////////////////////////////////////////////////////////////
///		ZMX3renderEx
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d ObjSurface H3d I I I] [H3d HMat3d I I I I I]
// -> [objet3D  Materiau  nbFace  U  V  Z  dist]
int ZMX3renderEx(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"MX3renderEx ");
#endif


	/* Traitement des callbacks de rendu */
	PROCEED_RENDER_CALLBACK

	// Macro de rendu GLOBAL
	GLOBAL_RENDER_FILL(false)

	CLEAN_UNUSED_DATAS


	// Dtermination de l'objet point par (x,y)
	int		width  = ((ZCamera*)node)->width  / 2;
	int		height = ((ZCamera*)node)->height / 2;

	int		result = NIL;
	int		mater  = NIL;
	float	u = 0, v = 0, z = 0, dist = 0;
	int		faceNb;

	if((x!=NIL)&&(y!=NIL))
	{
		ZObject*  obj = scene->Getinfo(MTOI(x)+width, height-MTOI(y), &u, &v, &z, NULL, &faceNb, &dist);
		if(obj!=NULL)
		{
			result = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),1)), (int)obj);
			ZMaterial	*mat = obj->GetMesh()->Faces[faceNb].GetMaterial();
			if((mat!=NULL)&&(result!=NIL))
			{
				mater = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),2)), (int)mat);
				if(mater!=NIL)		mater = PTOM(mater);
			}
			if(result!=NIL)		result = PTOM(result);
		}
	}

	// Pose le resultat sur la pile
	MMset(m,0,mater);
	MMpush(m,result);

	int tuple = MMmalloc(m, 7, TYPETAB);
	if(tuple==NIL)				{	MMset(m,0,NIL);		return MERRMEM;		}
	MMstore(m, tuple, 0, MMpull(m));
	MMstore(m, tuple, 1, MMget(m,0));

	if(mater!=NIL)
	{
		MMstore(m, tuple, 2, ITOM(faceNb));
		MMstore(m, tuple, 3, ITOM(AROUNDINT(u*CONST_TEX_COORD)));
		MMstore(m, tuple, 4, ITOM(AROUNDINT(v*CONST_TEX_COORD)));
		MMstore(m, tuple, 5, ITOM(AROUNDINT(-z*100.0f)));
		MMstore(m, tuple, 6, ITOM(AROUNDINT(dist*100.0f)));
	}
	else
	{
		MMstore(m, tuple, 2, NIL);
		MMstore(m, tuple, 3, NIL);
		MMstore(m, tuple, 4, NIL);
		MMstore(m, tuple, 5, NIL);
		MMstore(m, tuple, 6, NIL);
	}

	MMset(m,0,PTOM(tuple));

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZMX3renderExF
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d ObjSurface H3d I I I] [H3d HMat3d I F F F F]
// -> [objet3D  Materiau  nbFace  U  V  Z  dist]
int ZMX3renderExF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"MX3renderEx ");
#endif

	/* Traitement des callbacks de rendu */
	PROCEED_RENDER_CALLBACK

	// Macro de rendu GLOBAL
	GLOBAL_RENDER_FILL(false)

	CLEAN_UNUSED_DATAS

	// Dtermination de l'objet point par (x,y)
	int		width  = ((ZCamera*)node)->width  / 2;
	int		height = ((ZCamera*)node)->height / 2;

	int		result = NIL;
	int		mater  = NIL;
	float	u = 0, v = 0, z = 0, dist = 0;
	int		faceNb;

	if((x!=NIL)&&(y!=NIL))
	{
		ZObject*  obj = scene->Getinfo(MTOI(x)+width, height-MTOI(y), &u, &v, &z, NULL, &faceNb, &dist);
		if(obj!=NULL)
		{
			result = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),1)), (int)obj);
			ZMaterial	*mat = obj->GetMesh()->Faces[faceNb].GetMaterial();
			if((mat!=NULL)&&(result!=NIL))
			{
				mater = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),2)), (int)mat);
				if(mater!=NIL)		mater = PTOM(mater);
			}
			if(result!=NIL)		result = PTOM(result);
		}
	}

	// Pose le resultat sur la pile
	MMset(m,0,mater);
	MMpush(m,result);

	int tuple = MMmalloc(m, 7, TYPETAB);
	if(tuple==NIL)				{	MMset(m,0,NIL);		return MERRMEM;		}
	MMstore(m, tuple, 0, MMpull(m));
	MMstore(m, tuple, 1, MMget(m,0));

	if(mater!=NIL)
	{
		MMstore(m, tuple, 2, ITOM(faceNb));
		MMstore(m, tuple, 3, FTOM(u));
		MMstore(m, tuple, 4, FTOM(v));
		MMstore(m, tuple, 5, FTOM(-z*100.0f));
		MMstore(m, tuple, 6, FTOM(dist*100.0f));
	}
	else
	{
		MMstore(m, tuple, 2, NIL);
		MMstore(m, tuple, 3, NIL);
		MMstore(m, tuple, 4, NIL);
		MMstore(m, tuple, 5, NIL);
		MMstore(m, tuple, 6, NIL);
	}

    MMset(m,0,PTOM(tuple));

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZMX3Render														
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d ObjSurface H3d I I I] H3d
int ZMX3Render(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"MX3render ");
#endif


	/* Traitement des callbacks de rendu */
	PROCEED_RENDER_CALLBACK

	// Macro de rendu GLOBAL
	GLOBAL_RENDER_FILL(false)

	CLEAN_UNUSED_DATAS

	// Dtermination de l'objet point par (x,y)
	int		width  = ((ZCamera*)node)->width  / 2;
	int		height = ((ZCamera*)node)->height / 2;

	int		result = NIL;
	float	dist = 0;

	if((x!=NIL)&&(y!=NIL))
	{
		int faceNb;
		ZObject*  obj = scene->Getinfo(MTOI(x)+width, height-MTOI(y), NULL, NULL, NULL, NULL, &faceNb, &dist);
		if(obj!=NULL)
		{
			result = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),1)), (int)obj);
			if(result!=NIL)		result = PTOM(result);
		}
	}


#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	MMset(m,0,result);
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZMX3RenderM													
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d ObjSurface H3d I I I] [H3d HMat3d]
int ZMX3RenderM(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"MX3renderM ");
#endif

//$LBDEBUG NEW
struct timeval TBEGIN;
struct timeval TEND;
int tBEGIN, tEND;
gettimeofday(&TBEGIN,NULL);
  tBEGIN=(TBEGIN.tv_sec*1000)+(TBEGIN.tv_usec/1000);
///////////////////////////////////////////

	/* Traitement des callbacks de rendu */
	PROCEED_RENDER_CALLBACK

	// Macro de rendu GLOBAL
	GLOBAL_RENDER_FILL(false)

	CLEAN_UNUSED_DATAS



	// Dtermination de l'objet point par (x,y)
	int		width  = ((ZCamera*)node)->width  / 2;
	int		height = ((ZCamera*)node)->height / 2;

	int		result = NIL;
	int		mater  = NIL;
	float	dist = 0;

	if((x!=NIL)&&(y!=NIL))
	{
		int faceNb;
		ZObject*  obj = scene->Getinfo(MTOI(x)+width, height-MTOI(y), NULL, NULL, NULL, NULL, &faceNb, &dist);
		if(obj!=NULL)
		{
			result = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),1)), (int)obj);
			ZMaterial	*mat = obj->GetMesh()->Faces[faceNb].GetMaterial();
			if((mat!=NULL)&&(result!=NIL))
			{
				mater = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),2)), (int)mat);
				if(mater!=NIL)		mater = PTOM(mater);
			}
			if(result!=NIL)		result = PTOM(result);
		}
	}

	// Pose le resultat sur la pile
	MMset(m, 0, mater);
	MMpush(m, result);
	int tuple = MMmalloc(m, 2, TYPETAB);
	if(tuple==NIL)				{	MMset(m,0,NIL);		return MERRMEM;		}
	MMstore(m, tuple, 0, MMpull(m) );
	MMstore(m, tuple, 1, MMget(m,0) );

    MMset(m,0,PTOM(tuple));


//$LBDEBUG NEW
gettimeofday(&TEND,NULL);
  tEND=(TEND.tv_sec*1000)+(TEND.tv_usec/1000);
MMechostr (0, "\nMX3renderM TIME EXECUTION : %d\n", tEND - tBEGIN);

///////////////////////////////////////////

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZMX3wire
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d ObjSurface H3d I I I] [H3d HMat3d]
int ZMX3wire(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"MX3wire ");
#endif

	/* Traitement des callbacks de rendu */
	PROCEED_RENDER_CALLBACK

	// Macro de rendu GLOBAL
	GLOBAL_RENDER_FILL(true)

	CLEAN_UNUSED_DATAS



	// Dtermination de l'objet point par (x,y)
	int		width  = ((ZCamera*)node)->width  / 2;
	int		height = ((ZCamera*)node)->height / 2;

	int		result = NIL;
	int		mater  = NIL;
	float	dist = 0;

	if((x!=NIL)&&(y!=NIL))
	{
		int faceNb;
		ZObject*  obj = scene->Getinfo(MTOI(x)+width, height-MTOI(y),NULL, NULL, NULL, NULL, &faceNb, &dist);
		if(obj!=NULL)
		{
			result = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),1)), (int)obj);
			ZMaterial	*mat = obj->GetMesh()->Faces[faceNb].GetMaterial();
			if((mat!=NULL)&&(result!=NIL))
			{
				mater = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),2)), (int)mat);
				if(mater!=NIL)		mater = PTOM(mater);
			}
			if(result!=NIL)		result = PTOM(result);
		}
	}

	// Pose le resultat sur la pile
	MMset(m, 0, mater);
	MMpush(m, result);
	int tuple = MMmalloc(m, 2, TYPETAB);
	if(tuple==NIL)				{	MMset(m,0,NIL);		return MERRMEM;		}
	MMstore(m, tuple, 0, MMpull(m) );
	MMstore(m, tuple, 1, MMget(m,0) );

    MMset(m,0,PTOM(tuple));

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZMX3wirem
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d ObjSurface H3d I I I] [H3d HMat3d]
int ZMX3wirem(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"MX3wireM ");
#endif

	/* Traitement des callbacks de rendu */
	PROCEED_RENDER_CALLBACK

	// Macro de rendu GLOBAL
	GLOBAL_RENDER_FILL(true)

	CLEAN_UNUSED_DATAS



	// Dtermination de l'objet point par (x,y)
	int		width  = ((ZCamera*)node)->width  / 2;
	int		height = ((ZCamera*)node)->height / 2;

	int		result = NIL;
	int		mater  = NIL;
	float	dist = 0;

	if((x!=NIL)&&(y!=NIL))
	{
		int faceNb;
		ZObject*  obj = scene->Getinfo(MTOI(x)+width, height-MTOI(y), NULL, NULL, NULL, NULL, &faceNb, &dist);
		if(obj!=NULL)
		{
			result = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),1)), (int)obj);
			ZMaterial	*mat = obj->GetMesh()->Faces[faceNb].GetMaterial();
			if((mat!=NULL)&&(result!=NIL))
			{
				mater = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),2)), (int)mat);
				if(mater!=NIL)		mater = PTOM(mater);
			}
			if(result!=NIL)		result = PTOM(result);
		}
	}

	// Pose le resultat sur la pile
	MMset(m, 0, mater);
	MMpush(m, result);
	int tuple = MMmalloc(m, 2, TYPETAB);
	if(tuple==NIL)				{	MMset(m,0,NIL);		return MERRMEM;		}
	MMstore(m, tuple, 0, MMpull(m) );
	MMstore(m, tuple, 1, MMget(m,0) );

    MMset(m,0,PTOM(tuple));

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZMX3wireOrtho
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d ObjSurface H3d I I I] [H3d HMat3d]
int ZMX3wireOrtho(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"MX3wireOrtho ");
#endif


	/* Traitement des callbacks de rendu */
	PROCEED_RENDER_CALLBACK

	int		fond, y, x, h3d, surf, s3d;												
	ZScene	*scene;																	
	ZNode	*node, *father;															

	/*/////////////////////////////////////////////////////////////////									
	///		RENDU HARD												///									
	/////////////////////////////////////////////////////////////////*/									
	if(scolGLX->userACCEL)
	{
		HGLRC	hglrc;
		HWND hwnd;

		fond = MMpull(m);
		y	 = MMpull(m);
		x	 = MMpull(m);
		h3d	 = MMpull(m);
		surf = MMpull(m);

		if(surf==NIL) 		{   MMset(m,0,NIL);		return 0;	}

		//$LB hdc		= (HDC)	  MMfetch(m,MTOP(surf),1);
		hglrc	= (HGLRC) MMfetch(m,MTOP(surf),2);
		hwnd = (HWND) MMfetch (m, MTOP(surf), 3);

		if(wglGetCurrentContext()!=hglrc)
		{
			wglMakeCurrent(hwnd,hglrc);
		}

		s3d = MMget(m,0);
		if((s3d==NIL)||(h3d==NIL))		{   MMset(m,0,NIL);		return 0;	}

		scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
		if(scene==NULL)					{   MMset(m,0,NIL);		return 0;	}

		// Couleur de Fond
		fond = MTOI(fond);
		float	r = 0;
		float	g = 0;
		float	b = 0;

		if(fond!=NIL)
		{
			r = ((fond)&255)	 / CONST_COLOR;
			g = ((fond>>8)&255)	 / CONST_COLOR;
			b = ((fond>>16)&255) / CONST_COLOR;
		}

		// Recupration de la camera
		node = (ZNode*) MMfetch(m,MTOP(h3d),0);
		if((node==NULL)||(node->type!=CAM_TYPE_ID))		{   MMset(m,0,NIL);		return 0;	}
		scene->SetActiveCam((ZCamera*)node);

		father = getBigFather(node);


		// Prpare la camera par prcaution..
		ZMatrix		matx = ComputeWorldMatrix(node);
		((ZCamera*)node)->worldMat = matx;
		((ZCamera*)node)->worldPos.SetCoord(matx(0,3), matx(1,3), matx(2,3));
		
		
		// Rendu de la scene
		if(fond==NIL)		scene->Display(r,g,b, father, true, true, false);
		else				scene->Display(r,g,b, father, true, true, true);
	}
	/*/////////////////////////////////////////////////////////////////									
	///		RENDU SOFT				       ///									
	/////////////////////////////////////////////////////////////////*/									
	else																								
	{										    
		fond = MMpull(m);																			
		y	 = MMpull(m);																			
		x	 = MMpull(m);																			
		h3d	 = MMpull(m);																			
		surf = MMpull(m);																			
		s3d  = MMget(m,0);																			
															      
		if((surf==NIL)||(s3d==NIL)||(h3d==NIL))		{   MMset(m,0,NIL);		return 0;	}				
																		  
		scene = (ZScene*) MMfetch(m,MTOP(s3d),0);												
		if(scene==NULL)								{   MMset(m,0,NIL);		return 0;	}				
																	   
		RenderBuffer	buffer;																			
		if(fillRenderBuffer(m, &buffer, surf))			{   MMset(m,0,NIL);		return 0;	}			
																	 
		/* Couleur de Fond */																			
		fond = MTOI(fond);																				
		float	r = 0;																					
		float	g = 0;																					
		float	b = 0;																					
																   
		if(fond!=NIL)																					
		{															 
			r = ((fond)&255)	 / CONST_COLOR;															
			g = ((fond>>8)&255)	 / CONST_COLOR;															
			b = ((fond>>16)&255) / CONST_COLOR;															
		}												     
																
		/* Recupration de la camera */																	
		node = (ZNode*) MMfetch(m,MTOP(h3d),0);												
		if((node==NULL)||(node->type!=CAM_TYPE_ID))		{   MMset(m,0,NIL);		return 0;	}			
		scene->SetActiveCam((ZCamera*)node);															
															      
		father = getBigFather(node);															
																	    
		/* Prpare la camera par prcaution et aussi pour le calcul des subMatrices */					
		ZMatrix		matx = ComputeWorldMatrix(node);													
		((ZCamera*)node)->worldMat = matx;																
		((ZCamera*)node)->worldPos.SetCoord(matx(0,3), matx(1,3), matx(2,3));							

		/* Rendu de la scene */																			
		if(fond==NIL)		scene->DisplaySOFT(&buffer, r, g, b, father, true, true, false);
		else				scene->DisplaySOFT(&buffer, r, g, b, father, true, true, true);
	}


	CLEAN_UNUSED_DATAS


	// Dtermination de l'objet point par (x,y)
	int		width  = ((ZCamera*)node)->width  / 2;
	int		height = ((ZCamera*)node)->height / 2;

	int		result = NIL;
	int		mater  = NIL;
	float	dist = 0;

	if((x!=NIL)&&(y!=NIL))
	{
		int faceNb;
		ZObject*  obj = scene->Getinfo(MTOI(x)+width, height-MTOI(y), NULL, NULL, NULL, NULL, &faceNb, &dist);
		if(obj!=NULL)
		{
			result = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),1)), (int)obj);
			ZMaterial	*mat = obj->GetMesh()->Faces[faceNb].GetMaterial();
			if((mat!=NULL)&&(result!=NIL))
			{
				mater = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),2)), (int)mat);
				if(mater!=NIL)		mater = PTOM(mater);
			}
			if(result!=NIL)		result = PTOM(result);
		}
	}

	// Pose le resultat sur la pile
	MMset(m, 0, mater);
	MMpush(m, result);
	int tuple = MMmalloc(m, 2, TYPETAB);
	if(tuple==NIL)				{	MMset(m,0,NIL);		return MERRMEM;		}
	MMstore(m, tuple, 0, MMpull(m) );
	MMstore(m, tuple, 1, MMget(m,0) );

    MMset(m,0,PTOM(tuple));

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZMX3RenderInfo
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d I I] [H3d HMat3d I I I]
int ZMX3RenderInfo(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"MX3renderInfo ");
#endif

	int y	 = MMpull(m);
	int x	 = MMpull(m);
	int h3d	 = MMpull(m);
	int s3d	 = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(x==NIL)||(y==NIL))		{   MMset(m,0,NIL);		return 0;	}
	ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{   MMset(m,0,NIL);		return 0;	}

	// Recupration de la camera
	ZNodeGraph	*node = (ZNodeGraph*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=CAM_TYPE_ID))		{   MMset(m,0,NIL);		return 0;	}
	scene->SetActiveCam((ZCamera*)node);

	// Prpare la camera par prcaution..
	ZMatrix		matx = ComputeWorldMatrix(node);
	((ZCamera*)node)->worldMat = matx;
	((ZCamera*)node)->worldPos.SetCoord(matx(0,3), matx(1,3), matx(2,3));
	((ZCamera*)node)->ComputeMatrix();

	// Prpare la scne qui peut avoir chang
	ZNodeGraph	*father = (ZNodeGraph*) getBigFather(node);

	scene->World->createNodeLists(father);

	scene->World->ComputeMatrices(node, father, IdentityMatrix(), 1.0f, true);
	scene->World->TransformVertices();


	// Dtermination de l'objet point par (x,y)
	int		width  = ((ZCamera*)node)->width / 2;
	int		height = ((ZCamera*)node)->height / 2;

	int		result = NIL;
	int		mater  = NIL;
	float	u = 0, v = 0, z = 0, dist = 0;

	if((x!=NIL)&&(y!=NIL))
	{
		int faceNb;
		ZObject*  obj = scene->Getinfo(MTOI(x)+width, height-MTOI(y), &u, &v, &z, NULL, &faceNb, &dist);
		if(obj!=NULL)
		{
			result = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),1)), (int)obj);
			ZMaterial	*mat = obj->GetMesh()->Faces[faceNb].GetMaterial();
			if((mat!=NULL)&&(result!=NIL))
			{
				mater = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),2)), (int)mat);
				if(mater!=NIL)		mater = PTOM(mater);
			}
			if(result!=NIL)		result = PTOM(result);
		}
	}



	// Pose le resultat sur la pile
	MMset(m,0,mater);
	MMpush(m,result);

	int tuple = MMmalloc(m, 5, TYPETAB);
	if(tuple==NIL)				{	MMset(m,0,NIL);		return MERRMEM;		}
	MMstore(m, tuple, 0, MMpull(m));
	MMstore(m, tuple, 1, MMget(m,0));
	if(mater!=NIL)
	{
		MMstore(m, tuple, 2, ITOM(AROUNDINT(u*CONST_TEX_COORD)));
		MMstore(m, tuple, 3, ITOM(AROUNDINT(v*CONST_TEX_COORD)));
		MMstore(m, tuple, 4, ITOM(AROUNDINT(-z*100.0f)));
	}
	else
	{
		MMstore(m, tuple, 2, NIL);
		MMstore(m, tuple, 3, NIL);
		MMstore(m, tuple, 4, NIL);
	}

    MMset(m,0,PTOM(tuple));

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZMX3RenderInfoF
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d H3d I I] [H3d HMat3d F F F]
int ZMX3RenderInfoF(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"MX3renderInfoF ");
#endif

	int y	 = MMpull(m);
	int x	 = MMpull(m);
	int h3d	 = MMpull(m);
	int s3d	 = MMget(m,0);

	if((s3d==NIL)||(h3d==NIL)||(x==NIL)||(y==NIL))		{   MMset(m,0,NIL);		return 0;	}
	ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)					{   MMset(m,0,NIL);		return 0;	}

	// Recupration de la camera
	ZNodeGraph	*node = (ZNodeGraph*) MMfetch(m,MTOP(h3d),0);
	if((node==NULL)||(node->type!=CAM_TYPE_ID))		{   MMset(m,0,NIL);		return 0;	}
	scene->SetActiveCam((ZCamera*)node);

	// Prpare la camera par prcaution..
	ZMatrix		matx = ComputeWorldMatrix(node);
	((ZCamera*)node)->worldMat = matx;
	((ZCamera*)node)->worldPos.SetCoord(matx(0,3), matx(1,3), matx(2,3));
	((ZCamera*)node)->ComputeMatrix();

	// Prpare la scne qui peut avoir chang
	ZNodeGraph	*father = (ZNodeGraph*) getBigFather(node);

	scene->World->createNodeLists(father);

	scene->World->ComputeMatrices(node, father, IdentityMatrix(), 1.0f, true);
	scene->World->TransformVertices();


	// Dtermination de l'objet point par (x,y)
	int		width  = ((ZCamera*)node)->width / 2;
	int		height = ((ZCamera*)node)->height / 2;

	int		result = NIL;
	int		mater  = NIL;
	float	u = 0, v = 0, z = 0, dist = 0;

	if((x!=NIL)&&(y!=NIL))
	{
		int faceNb;
		ZObject*  obj = scene->Getinfo(MTOI(x)+width, height-MTOI(y), &u, &v, &z, NULL, &faceNb, &dist);
		if(obj!=NULL)
		{
			result = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),1)), (int)obj);
			ZMaterial	*mat = obj->GetMesh()->Faces[faceNb].GetMaterial();
			if((mat!=NULL)&&(result!=NIL))
			{
				mater = NodeTOHandle(m, MTOP(MMfetch(m,MTOP(s3d),2)), (int)mat);
				if(mater!=NIL)		mater = PTOM(mater);
			}
			if(result!=NIL)		result = PTOM(result);
		}
	}



	// Pose le resultat sur la pile
	MMset(m,0,mater);
	MMpush(m,result);

	int tuple = MMmalloc(m, 5, TYPETAB);
	if(tuple==NIL)				{	MMset(m,0,NIL);		return MERRMEM;		}
	MMstore(m, tuple, 0, MMpull(m));
	MMstore(m, tuple, 1, MMget(m,0));
	if(mater!=NIL)
	{
		MMstore(m, tuple, 2, FTOM(u));
		MMstore(m, tuple, 3, FTOM(v));
		MMstore(m, tuple, 4, FTOM(-z*100.0f));
	}
	else
	{
		MMstore(m, tuple, 2, NIL);
		MMstore(m, tuple, 3, NIL);
		MMstore(m, tuple, 4, NIL);
	}

    MMset(m,0,PTOM(tuple));

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3blitTexture
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d HTx3d ObjBitmap8] I


//$LB TODO TO DO : rtablir la fonction propritaire pour implmenter l'optimisation p4

//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3blitTexture16
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d HTx3d ObjBitmap] I

//$LB TODO TO DO : rtablir la fonction propritaire pour implmenter l'optimisation p4

#define ZM3blitTexture ZM3blitTexture16

int ZM3blitTexture16(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3blitTexture16 ");
#endif

	int bitm = MMpull(m);
	int text = MMpull(m);
	int s3d	 = MMget(m,0);

	if((s3d==NIL)||(text==NIL)||(bitm==NIL))		{   MMset(m,0,NIL);		return 0;	}
	ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)									{   MMset(m,0,NIL);		return 0;	}

    ZTexture	*tex = (ZTexture*) MMfetch(m,MTOP(text),0);
	if(tex==NULL)									{	MMset(m,0,NIL);		return 0;	}




	// Rcupre l'ObjBitmap et ses donnes
	//$LB PtrObjVoid		OB;
	PtrObjBitmap	B;

	if(bitm==NIL)								{	MMset(m,0,NIL);		return 0;	}
	
	//$LB
	/*
	OB = (PtrObjVoid) MMstart(m,MTOP(bitm));
	if(OB->Type != OBJ_TYPE_BITMAP<< 1)			{	MMset(m,0,NIL);		return 0;	}
	B = (PtrObjBitmap) MMstart(m,MTOP(OB->Buffer));
	*/
	if (!(B = (PtrObjBitmap) objdd_get_buffer (m, MTOP(bitm)))) { MMset(m,0,NIL); return 0;}



	//$LBDEBUG
	#ifdef _SCOL_DEBUG_
	MMechostr(MSKDEBUG, "\nflag 01\n");
	#endif


	//$LB unsigned short*		buf = (unsigned short*) B->Bitmap;								// BUFFER
	guint32*   buf = (guint32*) OBJBITMAP_GET_MEM(B);       // BUFFER


       	//$LBDEBUG
#ifdef _SCOL_DEBUG_	
	MMechostr(MSKDEBUG, "\nflag 02\n");
	#endif

							      

	// Prpare la texture
	//$LB
	if( (tex->Width != OBJBITMAP_GET_W(B)) || (tex->Height != OBJBITMAP_GET_H(B)) )
	{


	  	//$LBDEBUG
	  #ifdef _SCOL_DEBUG_
	MMechostr(MSKDEBUG, "\nflag 03\n");
	#endif

	        //$LB
		tex->Width  = OBJBITMAP_GET_W(B);
		tex->Height = OBJBITMAP_GET_H(B);

		if(tex->ImageModif!=NULL)			free(tex->ImageModif);
		tex->ImageModif	= (unsigned char *) malloc(tex->Width * tex->Height * 4);

		int		incremX;
		if(tex->Width&0x1)		incremX = tex->Width + 1;
		else					incremX = tex->Width;

		// Copie de la bitmap
		//$LB unsigned short	color;
		guint32 color;
		int				x, y, posii=0;

			//$LBDEBUG
		#ifdef _SCOL_DEBUG_
	MMechostr(MSKDEBUG, "\nflag 04\n");
	#endif

 
		// -----> on utilise la couleur de transparence d'origine
		//$LB unsigned short	colTransp = (tex->GetTranspB()>>3) + ((tex->GetTranspG()>>3)<<5) + ((tex->GetTranspR()>>3)<<10);
		guint32 colTransp = (tex->GetTranspR() << 16) | (tex->GetTranspG() <<8) | (tex->GetTranspB());


			//$LBDEBUG
		#ifdef _SCOL_DEBUG_
	MMechostr(MSKDEBUG, "\nflag 05\n");
	#endif


//$LB TODO
#ifdef	__OPTI_P4__
		if(infoP4)
		{
			__m128i		col;
			__m128i		mask31, maskA1, maskA2;
			__m128i		zero;

			unsigned short	color1, color2, retour;

			mask31	= _mm_set_epi16( 31, 31, 31, 0,   31, 31, 31, 0);
			maskA1	= _mm_set_epi16(  0,  0,  0, 255,  0,  0,  0, 0);
			maskA2	= _mm_set_epi16(  0,  0,  0, 0,    0,  0,  0, 255);
			zero	= _mm_setzero_si128();

			for(y=0; y<tex->Height; y++)
			{
				for(x=0; x<tex->Width; x+=2)
				{
					color1 = buf[(tex->Height-1-y)*incremX + x+0];
					color2 = buf[(tex->Height-1-y)*incremX + x+1];

					col = _mm_set_epi16(color1>>10, color1>>5, color1, 0,
										color2>>10, color2>>5, color2, 0);

					col = _mm_and_si128(col,mask31);

					col = _mm_slli_epi16(col, 3);								// col =  00rr 00gg 00bb 0000   00rr 00gg 00bb 0000

					if(color1!=colTransp)	col = _mm_or_si128(col,maskA1);		// col =  00rr 00gg 00bb 00aa   00rr 00gg 00bb 00aa
					if(color2!=colTransp)	col = _mm_or_si128(col,maskA2);

					col = _mm_packus_epi16(col,zero);							// col =  0000 0000 0000 0000   rrgg bbaa rrgg bbaa

					retour = _mm_extract_epi16(col,3);
					tex->ImageModif[posii+0] = (retour>>8)	&255;
					tex->ImageModif[posii+1] = (retour)	&255;

					retour = _mm_extract_epi16(col,2);
					tex->ImageModif[posii+2] = (retour>>8)	&255;
					tex->ImageModif[posii+3] = (retour)	&255;

					if(x!=tex->Width-1)
					{
						retour = _mm_extract_epi16(col,1);
						tex->ImageModif[posii+4] = (retour>>8)	&255;
						tex->ImageModif[posii+5] = (retour)	&255;

						retour = _mm_extract_epi16(col,0);
						tex->ImageModif[posii+6] = (retour>>8)	&255;
						tex->ImageModif[posii+7] = (retour)	&255;

						posii += 8;
					}
					else
						posii += 4;
				}
			}
		}
		else 
#endif 
		{


		  	//$LBDEBUG
		  #ifdef _SCOL_DEBUG_
	MMechostr(MSKDEBUG, "\nflag 06\n");
	#endif


	color = buf[(tex->Height-1-0)*incremX + 0];;

		  	//$LBDEBUG
	#ifdef _SCOL_DEBUG_
	MMechostr(MSKDEBUG, "\nflag 06 B\n");
	 #endif


	tex->ImageModif[posii+0] = (color >> 16) &0xFF;


		  	//$LBDEBUG
	#ifdef _SCOL_DEBUG_
	MMechostr(MSKDEBUG, "\nflag 06 C\n");
	#endif


			for(y=0; y<tex->Height; y++)
			{
				for(x=0; x<tex->Width; x++)
				{

					color = buf[(tex->Height-1-y)*incremX + x];




					//$LB
					/*
					tex->ImageModif[posii+0] = ((color>>10)&31)<<3;	
					tex->ImageModif[posii+1] = ((color>>5)&31)<<3;	
					tex->ImageModif[posii+2] = (color&31)<<3;		
					*/
					tex->ImageModif[posii+0] =  (color >> 16) &0xFF; //R
					tex->ImageModif[posii+1] = (color >> 8) &0xFF;   //G
					tex->ImageModif[posii+2] = color &0xFF;          //B


					if( color == colTransp )
					{
						tex->ImageModif[posii+3] = 0;
					}
					else
						tex->ImageModif[posii+3] = 255;

					posii += 4;
				}
			}


				//$LBDEBUG
			#ifdef _SCOL_DEBUG_
			MMechostr(MSKDEBUG, "\nflag 07\n");
			#endif


		}


		tex->activated = true;
		tex->renamed = false;			// becoz we have used the NEW flags of rendering


		if(scene->accelerated)
		{
			if(tex->ID_created==false)		{	glGenTextures(1, &(tex->texID));	tex->ID_created = true;	}
			glBindTexture(GL_TEXTURE_2D, tex->texID);

			if( tex->filter==TF_NONE )
			{
				glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
				glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
			}
			else if(tex->filter == TF_LINEAR)
			{
				glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
				glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
			}
			else if(tex->filter == TF_BILINEAR)
			{
				glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
				glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_NEAREST);
			}
			else if(tex->filter == TF_TRILINEAR)
			{
				glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
				glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
			}

			glTexImage2D(GL_TEXTURE_2D, 0, 4, tex->Width, tex->Height, 0, GL_RGBA, GL_UNSIGNED_BYTE, tex->ImageModif );
			if(tex->filter != TF_NONE)			gluBuild2DMipmaps( GL_TEXTURE_2D, 4, tex->Width, tex->Height, GL_RGBA, GL_UNSIGNED_BYTE, tex->ImageModif );

			free(tex->ImageModif);		tex->ImageModif=NULL;
		}
		else
		{
			tex->StretchImageModif();
			tex->SetupTexture();			
		}


			//$LBDEBUG
		#ifdef _SCOL_DEBUG_
	MMechostr(MSKDEBUG, "\nflag 08\n");
	#endif


	}
	else
	{

	  	//$LBDEBUG
	  #ifdef _SCOL_DEBUG_
	MMechostr(MSKDEBUG, "\nflag 09\n");
	#endif


		if(tex->ImageModif!=NULL)			free(tex->ImageModif);
		tex->ImageModif	= (unsigned char *) malloc(tex->Width * tex->Height * 4);

		int		incremX;
		if(tex->Width&0x1)		incremX = tex->Width + 1;
		else					incremX = tex->Width;

		// Copie de la bitmap
		//$LB unsigned short color;
		guint32 color;
		int				x, y, posii=0;



			//$LBDEBUG
		#ifdef _SCOL_DEBUG_
	MMechostr(MSKDEBUG, "\nflag 10\n");
	#endif


		// -----> on utilise la couleur de transparence d'origine
		//$LB unsigned short	colTransp = (tex->GetTranspB()>>3) + ((tex->GetTranspG()>>3)<<5) + ((tex->GetTranspR()>>3)<<10);
		guint32 colTransp = (tex->GetTranspR() << 16) | (tex->GetTranspG() <<8) | (tex->GetTranspB());


		
	//$LBDEBUG
		#ifdef _SCOL_DEBUG_
	MMechostr(MSKDEBUG, "\nflag 11\n");
	#endif


//$LB TODO
#ifdef	__OPTI_P4__
		if(infoP4)
		{
			__m128i		col;
			__m128i		mask31, maskA1, maskA2;
			__m128i		zero;

			unsigned short	color1, color2, retour;

			mask31	= _mm_set_epi16( 31, 31, 31, 0,   31, 31, 31, 0);
			maskA1	= _mm_set_epi16(  0,  0,  0, 255,  0,  0,  0, 0);
			maskA2	= _mm_set_epi16(  0,  0,  0, 0,    0,  0,  0, 255);
			zero	= _mm_setzero_si128();

			for(y=0; y<tex->Height; y++)
			{
				for(x=0; x<tex->Width; x+=2)
				{
					color1 = buf[(tex->Height-1-y)*incremX + x+0];
					color2 = buf[(tex->Height-1-y)*incremX + x+1];

					col = _mm_set_epi16(color1>>10, color1>>5, color1, 0,
										color2>>10, color2>>5, color2, 0);

					col = _mm_and_si128(col,mask31);

					col = _mm_slli_epi16(col, 3);								// col =  00rr 00gg 00bb 0000   00rr 00gg 00bb 0000

					if(color1!=colTransp)	col = _mm_or_si128(col,maskA1);		// col =  00rr 00gg 00bb 00aa   00rr 00gg 00bb 00aa
					if(color2!=colTransp)	col = _mm_or_si128(col,maskA2);

					col = _mm_packus_epi16(col,zero);							// col =  0000 0000 0000 0000   rrgg bbaa rrgg bbaa

					retour = _mm_extract_epi16(col,3);
					tex->ImageModif[posii+0] = (retour>>8)	&255;
					tex->ImageModif[posii+1] = (retour)	&255;

					retour = _mm_extract_epi16(col,2);
					tex->ImageModif[posii+2] = (retour>>8)	&255;
					tex->ImageModif[posii+3] = (retour)	&255;

					if(x!=tex->Width-1)
					{
						retour = _mm_extract_epi16(col,1);
						tex->ImageModif[posii+4] = (retour>>8)	&255;
						tex->ImageModif[posii+5] = (retour)	&255;

						retour = _mm_extract_epi16(col,0);
						tex->ImageModif[posii+6] = (retour>>8)	&255;
						tex->ImageModif[posii+7] = (retour)	&255;

						posii += 8;
					}
					else
						posii += 4;
				}
			}
		}
		else 
#endif 
		{

	//$LBDEBUG
		  #ifdef _SCOL_DEBUG_
	MMechostr(MSKDEBUG, "\nflag 12\n");
	#endif


			for(y=0; y<tex->Height; y++)
			{
				for(x=0; x<tex->Width; x++)
				{
					color = buf[(tex->Height-1-y)*incremX + x];
					
					//$LB
					/*
					tex->ImageModif[posii+0] = ((color>>10)&31)<<3;	
					tex->ImageModif[posii+1] = ((color>>5)&31)<<3;	
					tex->ImageModif[posii+2] = (color&31)<<3;		
					*/
					tex->ImageModif[posii+0] = (color >> 16) &0xFF; //B
					tex->ImageModif[posii+1] = (color >> 8) &0xFF;  //G
					tex->ImageModif[posii+2] = color &0xFF;         //R

					//if( ((abs(tex->ImageModif[posii+0]-tex->filterR)+abs(tex->filterG-tex->ImageModif[posii+1])+abs(tex->ImageModif[posii+2]-tex->filterB)) < (tex->rate*3+4)) )
					if( color == colTransp )
					{
						tex->ImageModif[posii+3] = 0;
					}
					else
						tex->ImageModif[posii+3] = 255;

					posii += 4;
				}
			}

	//$LBDEBUG
			#ifdef _SCOL_DEBUG_
	MMechostr(MSKDEBUG, "\nflag 13\n");
	#endif


		}

		tex->activated = true;
		tex->renamed = false;			// becoz we have used the NEW flags of rendering


		if(scene->accelerated)
		{
			if(tex->ID_created==false)		{	glGenTextures(1, &(tex->texID));	tex->ID_created = true;	}
			glBindTexture(GL_TEXTURE_2D, tex->texID);

			if( tex->filter==TF_NONE )
			{
				glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
				glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
			}
			else if(tex->filter == TF_LINEAR)
			{
				glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
				glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
			}
			else if(tex->filter == TF_BILINEAR)
			{
				glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
				glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_NEAREST);
			}
			else if(tex->filter == TF_TRILINEAR)
			{
				glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
				glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
			}

			glTexSubImage2D(GL_TEXTURE_2D, 0, 0, 0, tex->Width, tex->Height, GL_RGBA, GL_UNSIGNED_BYTE, tex->ImageModif);
			if(tex->filter != TF_NONE)			gluBuild2DMipmaps( GL_TEXTURE_2D, 4, tex->Width, tex->Height, GL_RGBA, GL_UNSIGNED_BYTE, tex->ImageModif );

			free(tex->ImageModif);		tex->ImageModif=NULL;
		}
		else
		{
			tex->StretchImageModif();
			tex->SetupTexture();
		}



	//$LBDEBUG
		#ifdef _SCOL_DEBUG_
	MMechostr(MSKDEBUG, "\nFFlag 14\n");
	#endif


	}



	//$LBDEBUG
		#ifdef _SCOL_DEBUG_
	MMechostr(MSKDEBUG, "\nFlag 15\n");
	#endif


	scene->textureModified = true;



#ifdef	_SCOL_DEBUG_
	MMechostr(0,"\nM3blitTexture16 ok\n");
#endif

	MMset(m,0,0);
	return 0;
}




//////////////////////////////////////////////////////////////////////////////////////////////
///		Buffer2texture
//////////////////////////////////////////////////////////////////////////////////////////////
int ZBuffer2texture(mmachine m, char *buffer, int width, int height)
{
	int text = MMpull(m);
	int s3d	 = MMget(m,0);

	if((s3d==NIL)||(text==NIL))					{   MMset(m,0,NIL);		return 0;	}
	ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)								{   MMset(m,0,NIL);		return 0;	}

    ZTexture	*tex = (ZTexture*) MMfetch(m,MTOP(text),0);
	if(tex==NULL)								{	MMset(m,0,NIL);		return 0;	}


	// Prpare la texture
	if( (tex->Width != width) || (tex->Height != height) )
	{
		tex->Width  = width;
		tex->Height = height;
		if(tex->ImageModif!=NULL)			free(tex->ImageModif);
		tex->ImageModif	= (unsigned char *) malloc(tex->Width * tex->Height * 4);

		int		srce=0, posii=0;

		for(int y=0; y<tex->Height; y++)
		{
			srce = (tex->Height-1-y) * tex->Width*3;

			for(int x=0; x<tex->Width; x++)
			{
				tex->ImageModif[posii+0] = buffer[srce+0];
				tex->ImageModif[posii+1] = buffer[srce+1];
				tex->ImageModif[posii+2] = buffer[srce+2];
				tex->ImageModif[posii+3] = 255;

				posii	+= 4;
				srce	+= 3;
			}
		}

		tex->activated = true;
		tex->renamed = false;			// becoz we have used the NEW flags of rendering

		if(scene->accelerated)
		{
			if(tex->ID_created==false)		{	glGenTextures(1, &(tex->texID));	tex->ID_created = true;	}
			glBindTexture(GL_TEXTURE_2D, tex->texID);

			glTexImage2D(GL_TEXTURE_2D, 0, 4, tex->Width, tex->Height, 0, GL_RGBA, GL_UNSIGNED_BYTE, tex->ImageModif );
			if(tex->filter != TF_NONE)			gluBuild2DMipmaps( GL_TEXTURE_2D, 4, tex->Width, tex->Height, GL_RGBA, GL_UNSIGNED_BYTE, tex->ImageModif );

			free(tex->ImageModif);		tex->ImageModif=NULL;
		}
		else
		{
			tex->StretchImageModif();
			tex->SetupTexture();
		}
	}
	else
	{
		if(tex->ImageModif!=NULL)			free(tex->ImageModif);
		tex->ImageModif	= (unsigned char *) malloc(tex->Width * tex->Height * 4);

		int		srce=0, posii=0;

		for(int y=0; y<tex->Height; y++)
		{
			srce = (tex->Height-1-y) * tex->Width*3;

			for(int x=0; x<tex->Width; x++)
			{
				tex->ImageModif[posii+0] = buffer[srce+0];
				tex->ImageModif[posii+1] = buffer[srce+1];
				tex->ImageModif[posii+2] = buffer[srce+2];
				tex->ImageModif[posii+3] = 255;

				posii	+= 4;
				srce	+= 3;
			}
		}

		tex->activated = true;
		tex->renamed = false;			// becoz we have used the NEW flags of rendering

		if(scene->accelerated)
		{
			if(tex->ID_created==false)		{	glGenTextures(1, &(tex->texID));	tex->ID_created = true;	}
			glBindTexture(GL_TEXTURE_2D, tex->texID);
			
			glTexSubImage2D(GL_TEXTURE_2D, 0, 0, 0, tex->Width, tex->Height, GL_RGBA, GL_UNSIGNED_BYTE, tex->ImageModif);
			if(tex->filter != TF_NONE)			gluBuild2DMipmaps( GL_TEXTURE_2D, 4, tex->Width, tex->Height, GL_RGBA, GL_UNSIGNED_BYTE, tex->ImageModif );

			free(tex->ImageModif);		tex->ImageModif=NULL;
		}
		else
		{
			tex->StretchImageModif();
			tex->SetupTexture();
		}
	}

	scene->textureModified = true;

	MMset(m,0,text);
	return 0;
}







int Mgethxn(char *c,int l)
{
  int a,k,i,n;
  
  k=0;
  for(i=0;i<l;i++)
  {
	  a=c[i];
      if ((a>='0')&&(a<='9')) n=a-'0';
      else if ((a>='A')&&(a<='F')) n=10+a-'A';
      else if ((a>='a')&&(a<='f')) n=10+a-'a';
      else n=0;
      k=(k<<4)+n;
    }
  return k;
}

int myabs(int a,int b)
{
	if (a>b) return a-b;
	return b-a;
}


int hsv2rgb(float h, float s, float v)
{
	int		i;
	int	r,g,b;
	float	f,p,q,t;
		
	v*=255.;
	if (s==0.) r=g=b=(int)v;
	else
	{
		while (h>=360.) h-=360.;
		while (h<0.) h+=360.;
		h/=60.;
		i=(int)floor(h); f=h-(float)i;
		p=v*(1.-s);
		q=v*(1.-s*f);
		t=v*(1.-s*(1.-f));
		switch(i)	{
			case 0:
						r=(int)v; g=(int)t; b=(int)p;
						break;
			case 1:
						r=(int)q; g=(int)v; b=(int)p;
						break;
			case 2:
						r=(int)p; g=(int)v; b=(int)t;
						break;
			case 3:
						r=(int)p; g=(int)q; b=(int)v;
						break;
			case 4:
						r=(int)t; g=(int)p; b=(int)v;
						break;
			case 5:
						r=(int)v; g=(int)p; b=(int)q;
						break;
						}
		}
	return ((r<<7)&0x7c00)+((g<<2)&0x3e0)+(b>>3);
}


int rgb2hsv(int c,float *rh,float *rs,float *rv)
{
	int r,g,b,max,min;
	float h,s,v,delta;

	r=(c>>10)&0x1f;
	g=(c>>5)&0x1f;
	b=c&0x1f;
	if (r>g) max=r; else max=g;
	if (b>max) max=b;
	if (r<g) min=r; else min=g;
	if (b<min) min=b;
	v=max;
	v/=31;
	if (max)
	{
		s=max-min;
		s/=max;
	}
	else s=0;
	if (s==0) h=0;
	else
	{
		delta=max-min;
		if (r==max) h=(g-b)/delta;
		else if (g==max) h=2+(b-r)/delta;
		else h=4+(r-g)/delta;
		h*=60;
		if (h<0) h+=360;
	}
	*rh=h; *rs=s; *rv=v;
	return 0;
}



#define COLORTRANS	1


//$LB TODO TO DO : comprendre... :) et convertir les couleurs...
int M3Dfilter(char *s, int l, guint32 *src, int length)
{
	int		i=0;
	int		col24, col, coef, k, x, colr, colg, colb;
	int		ang, sat16;
	float	sat, rh, rs, rv;
	int		transp=0;

	while(i<l)
	{
		if((s[i]=='C')&&(l-i>8))
		{
			col24	= Mgethxn(s+i+1,6);
			col		= ((col24&0xf80000)>>19)+((col24&0xf800)>>6)+((col24&0xf8)<<7);
			coef	= Mgethxn(s+i+7,2);
			for(k=0; k<length; k++)
			{
				x = src[k];
				src[k] = ((((x&0x7c00)*(256-coef)+(col&0x7c00)*coef)>>8)&0x7c00)+
						 ((((x&0x3e0)*(256-coef)+(col&0x3e0)*coef)>>8)&0x3e0)+
						 ((((x&0x1f)*(256-coef)+(col&0x1f)*coef)>>8)&0x1f);
			}
			i+=9;
		}
		else if((s[i]=='A')&&(l-i>8))
		{
			col24	= Mgethxn(s+i+1,6);
			col		= ((col24&0xf80000)>>19)+((col24&0xf800)>>6)+((col24&0xf8)<<7);
			//transp = col;
			transp	= COLORTRANS;
			colr = (col&0x7c00)>>10;
			colg = (col&0x3e0)>>5;
			colb = col&0x1f;

			coef = (Mgethxn(s+i+7,2)>>3)*3;
			for(k=0; k<length; k++)
			{
				x = src[k];
				if(x==COLORTRANS)	src[k]=0;
				else 
					if ((myabs((x&0x7c00)>>10,colr)+myabs((x&0x3e0)>>5,colg)+myabs(x&0x1f,colb))<coef)			src[k]=COLORTRANS;
			}
			i+=9;
		}
		else if(s[i]=='X')
		{
			for(k=0; k<length; k++)
			{
				x = src[k];
				src[k] = ((x&0x7c00)>>10)+((x&0x3ff)<<5);
			}
			i++;
		}
		else if(s[i]=='Y')
		{
			for(k=0; k<length; k++)
			{
				x = src[k];
				src[k] = ((x&0x7fe0)>>5)+((x&0x1f)<<10);
			}
			i++;
		}
		else if((s[i]=='R')&&(l-i>4))
		{
			ang = (Mgethxn(s+i+1,4)*360)>>16;
			for(k=0; k<length; k++)
			{
				rgb2hsv(src[k], &rh, &rs, &rv);
				src[k] = hsv2rgb(rh+ang, rs, rv);
			}
			i+=5;
		}
		else if((s[i]=='S')&&(l-i>6))
		{
			sat16 = Mgethxn(s+i+1,4);
			sat  = sat16;
			sat /= CONST_ANGLE;
			coef = Mgethxn(s+i+5,2);
			for(k=0; k<length; k++)
			{
				rgb2hsv(src[k], &rh, &rs, &rv);
				src[k]=hsv2rgb(rh, (rs*(256-coef)+sat*coef)/256, rv);
			}
			i+=7;
		}
		else i++;
	}
	return transp;
}

//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3filter
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [ObjBitmap S] ObjBitmap
int ZM3filter(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3filter ");
#endif

	int flag = MMpull(m);
    int bitm = MMget(m,0);
    
	if((flag==NIL)||(bitm==NIL))		return 0;
	
	char *s = MMstartstr(m,MTOP(flag));

	// recupere les donnes sur l'ObjBitmap
	//$LB PtrObjVoid		OB;
	PtrObjBitmap	B;

	if(bitm==NIL)								{	MMset(m,0,NIL);		return 0;	}

	//$LB
	/*
    OB = (PtrObjVoid) MMstart(m,MTOP(bitm));
    if(OB->Type != OBJ_TYPE_BITMAP<< 1)			{	MMset(m,0,NIL);		return 0;	}
    B = (PtrObjBitmap) MMstart(m,MTOP(OB->Buffer));
    */
	B = (PtrObjBitmap) objdd_get_buffer (m, MTOP(bitm));

	//$LB M3Dfilter(s, strlen(s), (short*)(B->Bitmap), (B->TailleH*B->BPL)>>1);
	M3Dfilter (s, strlen(s), (guint32*)OBJBITMAP_GET_MEM(B), (OBJBITMAP_GET_H(B) * OBJBITMAP_GET_BPL(B)>>2));

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3nbVisiblePoly
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d] I
int ZM3nbVisiblePoly(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3nbVisiblePoly ");
#endif
	MMset(m,0,NIL);
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif
	return 0;
}



//////////////////////////////////////////////////////////////////////////////////////////////
///		ZM3nbUsedPolygons
//////////////////////////////////////////////////////////////////////////////////////////////
// fun [S3d] I
int ZM3nbUsedPolygons(mmachine m)
{
#ifdef	_SCOL_DEBUG_
	MMechostr(0,"M3nbUsedPolygons ");
#endif

	int s3d = MMget(m,0);

	if(s3d==NIL)						{   MMset(m,0,NIL);		return 0;	}
	ZScene	*scene = (ZScene*) MMfetch(m,MTOP(s3d),0);
	if(scene==NULL)						{   MMset(m,0,NIL);		return 0;	}


	ZWorld	*world = scene->World;
	int nbPoly = 0;

	for(int i=0; i<world->objList.Size(); i++)
	{
		if(world->objList[i]->GetMesh())		nbPoly += world->objList[i]->GetMesh()->NbFaces;
	}

	MMset(m,0,ITOM(nbPoly));

#ifdef	_SCOL_DEBUG_
	MMechostr(0,"ok\n");
#endif

	return 0;
}
